

//*** CONTROLANDO LA BUSQUEDA
//tipomov excluded_mov;

bool problem;

void computer_mov(void)
{
   int alpha,beta;
   int Root_eval,BestEval;
   int i,j;
   int movlegal  = 0;
   int cambia_mejor_mov[64];
   bool Root_Jaque;
   bool mov_facil = true;
   tipojugada tmp,book_move; 

   Trans_Age++; // En cada nueva busqueda aumenta la edad de la hash
   stop_search = false;
   start_time = GetTime();
   stop_time = start_time + maxtiempo;
   Profundidad = 0; 
   memset (matekiller, 0, sizeof(matekiller));
   memset (killer1, 0, sizeof(killer1));
   memset (killer2, 0, sizeof(killer2));
   memset (good_mov, 0, sizeof(good_mov));
   max_good_mov = 0;
   book_move.origen = 0;book_move.destino = 0;
  // excluded_mov.origen = 0;
   //excluded_mov.destino = 0;
//** Generamos todos los movimientos
	genera_todo();

// Pequeisimo libro de aperturas, solo para el primer movimiento
if(hply <= 1 && !modotest) {
	int origen  = 0;
	int destino = 0;

	// Para el primer movimiento se podria alegir aleatoriamente
	// e4, o d4, pero con d4, se saca antes del libro de aperturas
	// al contrario, y ademas es mas seguro.
	if (hply == 0 && !Analiza) {
		origen = D2; destino = D4;
		for(i = 0; i < PilaMax[1]; i++) {
			if(ListaMov[i].destino == destino)
			book_move = ListaMov[i];
		}
	}
	else if(hply == 1 && !Analiza) {
		switch(historial[0].destino){
		case D4: {origen = G8; destino = F6;break;}
        case F4: {origen = D7; destino = D5;break;}
        case F3: if(historial[0].origen == G1){  
				  origen = D7; destino = D5;break;}
		default : origen = E7; destino = E5;
		}
		for(i = 0; i < PilaMax[1]; i++) {
			if(ListaMov[i].destino == destino && ListaMov[i].origen == origen)
			book_move = ListaMov[i];
		}
	}
}

//** Comprobamos si hay algun movimiento legal, y de
//** paso asignamos un valor, a cada jugada utilizando
//** una mini busqueda de 3 ply, y luego las ordenamos.

for(i = 0; i < PilaMax[1]; i++) {
	 MakeMove(i);
     if(es_legal()) {
		 movlegal++;
		//ListaMov[i].eval =  -root_search(-VALMATE,VALMATE,(3*UNPLY));
	 }
	 else ListaMov[i].eval = -VALMATE;
     retrocede(); 	
}

//ordenamos los movimientos
/*for(i = 0; i < PilaMax[1]; i++) {
	for (j = 0 ; j < i; j++){	
		if (ListaMov[i].eval > ListaMov[j].eval){
			tmp = ListaMov[j];
			ListaMov[j] = ListaMov[i];
			ListaMov[i] = tmp;
		}
	}
}
*/
/*
if(!wboard){	
// muestra la lista de movimientos con su evaluacion ordenada
printf("\n  "); 
	for(i = 0; i < PilaMax[1]; i++) {
		muestra_mov(i);
		printf("  mov %2d =  %4d \n  ",i,ListaMov[i].eval); 
	}
}
*/

//** Comprobamos que no sea una posicion de tablas o mate
if(movlegal == 0){
//** Comprobamos si estamos en jaque
	if(Color == BLANCAS)
	     Root_Jaque = casilla_atacada(Pos_RB,NEGRAS);
	else Root_Jaque = casilla_atacada(Pos_RN,BLANCAS);

	if(!Root_Jaque){
		if(wboard)  printf("1/2-1/2 {Stalemate}\n");
		else  printf("\n TABLAS AHOGADO!!...\n");
			return;
	}
	else if(!wboard) printf("\n MATE!!...\n");
	return;		 
}

//*********** EMPEZAMOS LA BUSQUEDA EN EL ARBOL ***********

   Profundidad = 0; 
   Nodos = 0; 
   NulProb = NulExito = 0;
   Hash_Probe = Hash_Hits = 0; 
   PosC = PosL = PosH = 0;
   Razor = Estatic = Futil  = LMR = Prueba = 0;
   Ext_jaque = Extensores = 0;

   /** Este es el bucle principal del motor de bsqueda
   *** Empezamos con Ply 1 hasta Ply mximo y nos paramos cuando se acabe
   *** el tiempo o se pulse una tecla, 
   *** En cada Ply llamamos a search() con el parametro Ply, que se ira
   *** reduciendo en uno, en cada llamada recursiva a si misma,  */

   for(Ply = 1; Ply <= MAX_PLY; Ply++) {

	   problem = false;
	   // para saber si la posicion es compleja
	   cambia_mejor_mov[Ply] = 0;
	   // Si tenemos un mov de libro lo ejecutamos
	   if(book_move.destino > 0){
		   ListaMov[0] = book_move;
		   alpha = 0;
		   break;
	   }
 //*** Si estamos en el primer ply,entonces ponemos las ventana alpha-beta
 //*** a +- infinito (VALMATE), para que quepa cualquier jugada.
 //*** En cualquier otro ply restringimos las ventanas a los valores encon-
 //*** trados en el ply anterior, +- (el valor de un peon/2).     

      if(Ply==1) {
		alpha = -VALMATE;
		beta  =  VALMATE;
      }

      else {
		alpha = alpha - 40;
		beta  = alpha + 40;
		//alpha = alpha - 100;
		//beta  = alpha + 100;
		if(alpha < -VALMATE) alpha = -VALMATE;
		if(beta >   VALMATE) beta  =  VALMATE;
      }
	  
	//** Comprobamos si tenemos que salir del bucle, if...
	
    // Si se nos acaba el tiempo 
      if(stop_search == true) break;

      // Si hemos tenido problemas en el ply anterior, agotamos todo
	  // el tiempo del que disponemos, (problemas = true para dentro de
	  // search() ??
	  if(Ply > 8 && cambia_mejor_mov[Ply-1] >= 2 && !en_tiempo_contrario){
			problem = true;
			if ((GetTime() - start_time) >  maxtiempo) break;
	  }
	 
    // Si hemos consumido la mitad del tiempo asignado no entramos
    // en otro ply, lo mas probable es que no podamos acabarlo.
      else if ((GetTime() - start_time) >=  (maxtiempo * 60)/100
		  && !en_tiempo_contrario) break;

	// Si solo tenemos un movimiento legal en esta posicion
	  if(movlegal == 1 && Ply >= 5) break;  

    // Si es una recaptura de Torre o Dama, y no se ha cambiado de
    // mejor movimiento, lo consideraremos un movimiento facil 
	  if(!Analiza && !en_tiempo_contrario &&
		  mov_facil && Ply > 10 && 
          ListaMov[0].capturada >= T_B &&
		 (historial[hply-1].capturada ==
		  ListaMov[0].capturada) &&
         (GetTime() - start_time)>= (maxtiempo/8)){
		 break;
	  } 
	

//** Bucle para ejecutar todos los mov disponibles, en este momento los
//** ejecutamos en el orden en que se generaron, excepto el mov de la VP, 
//** que siempre lo colocamos en primer lugar, asi sera el primero en la 
//** siguiente busqueda, y ademas lo tendremos disponible para ejecutarlo
//** cuando se requiera.

      for(i = 0; i < PilaMax[1]; i++) {

// Si se nos acaba el tiempo paramos de ver movimientos
     if(stop_search == true) break;
       
	 VarPrinc[Profundidad][Profundidad].origen = 0;

// En modo consola, mostramos el movimiento que estamos analizando
	 if(!wboard){
	 printf(" Ply (%2d)  Analizando..(%d) ",Ply,i+1);
	 muestra_mov(i);
	 printf(" \r  ");
	 }
 
//* Si hemos visto mate nos salimos y ejecutamos el movimiento	
	 if(alpha >= VALMATE - 100 && Ply >= 9 ){
		 MuestraVarPrinc(Ply,Root_eval);
		 Ply = MAX_PLY;
		 break; 
	 }
	 
//* ejecutamos el movimiento y comprobamos que sea legal, seguro que al menos
//* hay un movimiento legal, de lo contrario, no estariamos aqui.
	 MakeMove(i);
	 if(ListaMov[i].eval == -VALMATE){ //ES ILEGAL
         retrocede(); 	
         continue;
	 }

//** Tambien aprovechamos que estamos en la raiz, para poner la variable Var_
//** Principal a TRUE o FALSE, nos puede ser de mucha utilidad en search(). 
//** Recordemos que si el movimiento (i) = 0, quiere decir que es el primero 
//** de la lista, y por lo tanto es el primer movimiento de la VP.  
	 if(i == 0 )  Var_Principal = true;
	 else         Var_Principal = false;

//* Ponemos a trabajar el motor de busqueda, que se ira llamanso a si mismo
//* recursivamente, reduciendo Ply en 1, (Ply pasara a llamarse Depth dentro
//* de la rutina search) que podra reducirse aun mas, o incrementarse, segun
//* las necesidades de la posicion, hasta llegar a ser 0, entonces toma el
//* control otra rutina, Qsearch(), que solo mirara los movimientos que sean
//* capturas, para finalmente devolvernos el valor de la posicion.
	 
	 Root_eval = -root_search(-beta,-alpha,(Ply*UNPLY)-UNPLY);
	
//* Retrocedemos el movimiento, y analizamos el valor que hemos recibido, 
//* si ha tenido problemas con los limites marcados por (a,b) tenemos trabajo
//* aadido.
	 retrocede();
	 	  
//* Si es el primer movimiento de la lista, se trata del mejor movimiento 
//* encontrado hasta ahora, y candidato a ser jugado, merece una atencion
//* especial.
	 if(i == 0) {
      
//* Parece que nuestro movimiento candidato, no es tan bueno como creiamos, es
//* inferior, pero no sabemos cuanto, porque la ventana alpha le ha impedido
//* averiguarlo. Tenemos que ampliar (a) para averiguar el valor exacto del
//* movimiento; lo necesitamos para adaptar (a,b) a la nueva realidad; para
//* poder compararlo con otro movimiento y para mostrar una informacion real 
//* de lo que sucede.
//* Aqui algunos programadores hacen un segundo intento de ventana reducida,
//* por ejemplo, 2 o 3 peones, nosotros directamente abrimos la ventana al
//* maximo.

	 if(Root_eval <= alpha ) {  
	    alpha = -VALMATE;
	    beta  =  Root_eval;
	    MakeMove(i);
		Root_eval = -root_search(-beta,-alpha,(Ply*UNPLY)-UNPLY);
	    retrocede();
	 }

//* Bueno ahora es todo lo contrario, y parece que el movimiento es incluso mejor
//* de lo esperado, no obstante y por los mismos motivos que en el caso anterior,
//* necesitamos saber el valor exacto del movimiento, asi que ensanchamos (b) al
//* maximo.

	 else if(Root_eval >= beta) {  
	    alpha = Root_eval;
	    beta  = VALMATE;
	    MakeMove(i);
		Root_eval = -root_search(-beta,-alpha,(Ply*UNPLY)-UNPLY);
	    retrocede();
	 }

//* Ajustamos las ventana para el resto de movimientos, las ajustamos a su minima
//* expresion en torno al valor de nuestro movimiento candidato, pues las  
//* probabilidades de que sea un movimiento inferior son muy altas, y ademas solo 
//* nos interesa saber si es mejor que el candidato.
//* Tambien actualizamos la lista de movimientos de la Variante Principal, con este
//* movimiento, y la mostramos en pantalla.
	
		alpha = Root_eval;
	    beta  = alpha+1;
	    ActVarPrincipal(i);

		if (Ply >= 6) MuestraVarPrinc(Ply,Root_eval);
		
//* Si hemos visto mate nos salimos y ejecutamos el movimiento	
		if(alpha > VALMATE - 100 ) {
			Ply = MAX_PLY;
			break;
		}

	}//if(i==0)

//* Aqui solo nos interesa saber si el movimiento es mejor que el candidato,
//* si es asi, tenemos que ensanchar beta para averiguar el valor exacto.
	 else { 
	    if(Root_eval > alpha) {
	       BestEval  = alpha; 
	       alpha     = Root_eval;
	       beta      = VALMATE;       
	       MakeMove(i);
		   Root_eval = -root_search(-beta,-alpha,(Ply*UNPLY)-UNPLY);
	       retrocede();

		//* Si efectivamente este movimiento es mejor que el candidato, reorganizamos
		//* las ventanas (a,b) a su minima expresion en torno al nuevo valor, para 
		//* seguir analizando los movimientos que quedan; igualmente actualizamos la
		//* Variante principal y la mostramos.
	    if(Root_eval > BestEval) {  
		   alpha = Root_eval;
		   beta  = alpha+1;
		   ActVarPrincipal(i);
		   if (Ply >= 6) MuestraVarPrinc(Ply,Root_eval); 
      
		  //* Ponemos la mejor jugada en primer lugar (en ListaMov[0]),
          //* haciendole sitio, desplazando el resto de movimientos.	
		  tmp = ListaMov[i];
		  for(j = i; j > 0; j--) {
             ListaMov[j] = ListaMov[j-1];
		  }
		  ListaMov[0] = tmp;
		  // Si cambiamos de movimiento candidato despues del ply 3, 
		  // no lo consideramos un movimiento facil.
		  if (Ply > 3) mov_facil = false;
		  // para saber cuantas veces hemos cambiado en un mismo Ply
		  cambia_mejor_mov[Ply]++;
	       }//if(eval > BestEval)
	    }//if(eval > alpha)
	 }//else no estamos en Var_Principal  
   }//for(i=0
   
 
 }//for(Ply=1;
 
 
//* Nos hemos salido del bucle Ply, bien porque hemos visto mate, porque se 
//* ha acabado el tiempo, porque solo habia un movimiento, o se ha pulsado
//* una tecla, analizamos el resultado e informamos por pantalla o a WB.

	  // Si estamos en modo WinBoard
	  if(wboard && !en_tiempo_contrario && !Analiza){

	    /* //* Si la posicion es desesperada, abandonamos
			if(Root_eval < -600){
				Abandonar++;
				if(Abandonar >= 3 &&
				   Crono_oponente > 20000 &&
				   FichasBB > 0 && PeonesBB > 0 &&
				   FichasNN > 0 && PeonesNN > 0){
					printf("resign \n"); 
					fflush(stdout);
				}
			}
			else Abandonar = 0;*/

	     muestra_mov(0); 
		 MakeMove(0);
		 
	     // Si ponderar = true, seguimos analizando
		  if(ponderar == true && quedan > 2 ){ //&& Abandonar == 0){
             en_tiempo_contrario = true;
			 computer_mov();
		  }
	  }//wboard 

	  // Si estamos en modo consola
	  else if(!wboard){
		 
         int crono = (GetTime()-start_time)/1000;
		 printf("\n\n  Mi jugada: ");
		 muestra_mov(0);
		 MakeMove(0);

		 // Si henos visto mate, lo anunciamos en modo consola
		 if(alpha >= VALMATE - 30) {
		  if((VALMATE-2-alpha)/2 == 0) {
			  if(Color == NEGRAS)
			  printf ("  blancas ganan JAQUE MATE   ");
			  else
			  printf ("  negras ganan JAQUE MATE   ");
		  }
		  else printf("  MATE en %d  ",(VALMATE-2-alpha)/2);
        } //alpha >= VALMATE - 30

		 printf("\n\n  Razoring   %9d    Nul_estatic %9d\n",Razor,Estatic);
		 printf("  Futility   %9d    LMR         %9d   En prueba     %9d\n",Futil,LMR ,Prueba);
		 printf("  Extensores %9d    Ex_jaque    %9d \n",Extensores,Ext_jaque);
		 printf("  Hash_prob  %9d    Hash_exito  %9d   %2d%%\n",Hash_Probe, Hash_Hits,(Hash_Hits*100)/Max(1,Hash_Probe));
		 printf("  Nulos_prob %9d    Nulos_exito %9d   %2d%%\n",NulProb,NulExito,(NulExito*100)/Max(1,NulProb));
		 printf("  Eval_hash  %9d    Eval_lazy   %9d   Eval_completa %9d\n",PosH,PosC,PosL);
		 printf("\n  Crono = %ld seg, Pos/Seg = %d\n",crono,Nodos/Max(1,crono)); 

		 if(!modotest)
		 dibuja_tablero();

	  }//modo consola
 
}//computer_mov 



//****************************************************************
int		   eval_hist[64];

static int futil_margin1[11] =  { 150, 150, 150, 150, 400, 400 ,400,500,500,600,600 };
static int futil_margin2[11] =  { 150, 200, 200, 400, 400, 400 ,400,600,600,700,700 };
static int FutilityMoveCount[15] = {6,6,6,6,10,14,18,22,26,30,34,38,42,46,50}; //ori-1


const int lmr_red[32][64] = {
{0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
{0, 1, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4},
{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 1, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6},
{0, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4, 4, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6}
};


int search(int alpha,int beta,int Depth,bool hacer_nulo,int check){
   int   eval,evaluacion,BestEval;
   int   valorhash;
   int   mov_legales,i;
   int   next_depth;
   int   lmr_reduce;
   int   futil_eval;
   int   hash_flag = Hash_ALPHA;
 
   bool  nodo_pv =  ((beta - alpha) > 1);
   bool  EnJaque      = false;
   bool  jaque        = false;
   bool  extendido    = false;
   bool  amenaza_mate = false;
   bool  futil_ok     = false;
   bool  cut_nodo;
   bool  fichas_BN    = (FichasBB > 0 && FichasNN > 0);
   bool  cut;
   bool  nulo_falla = false;
   bool  dofull;
   bool  tt_null_ok = true;
   bool  mejorando;
   bool  solo_peones = false;
   bool  rey_solo = false;
  // Para el movimiento nulo
   int R;
   int Vhply;
   int nmscore;
   int Valpaso;
   int v_nulo = 0;
   U64 Vhash;

tipomov bestmove = nomove;
//tipomov excluded_mov = nomove;
VarPrinc[Profundidad][Profundidad].origen = 0;	

//** Si no se utiliza root_search(), tendriamos que activar
//** este codigo, o bien comprobar los jaques para incluirlo
//** como parametro en la primera llamada a search().
/*
if(check == desconocido){
 if(Color == BLANCAS)
	  EnJaque = casilla_atacada(Pos_RB,NEGRAS);
 else EnJaque = casilla_atacada(Pos_RN,BLANCAS);
} 
else */ EnJaque = check;

//** Si hemos llegado a la frontera, nos vamos a qsearch()
if (Depth < UNPLY) return qsearch(alpha, beta, 0);
//if(!EnJaque && Depth < UNPLY) return qsearch(alpha,beta, 0); 

// Si hemos llegado a la profundidad maxima
if(Profundidad >= PROF_MAXIMA){
	return evalua_posicion(alpha,beta);
}

// Si se repite la jugada 2 veces, le decimos al motor que son
// tablas, ya decidira si le interesa o no, seguir por ese camino.
if(repeticion() || fifty >= 100){	   
	 return 0;
}

//** Mate distance pruning
if(Profundidad){
 int mate_score = VALMATE - Profundidad;
  if (mate_score < beta) {
    beta = mate_score;
    if (alpha >= mate_score)
    return alpha;
  }
  mate_score = -VALMATE + Profundidad;
  if (mate_score > alpha) {
    alpha = mate_score;
    if (beta <= mate_score)
    return beta;
  }
}

//Comprobamos si aun queda tiempo
if (!(Nodos & 0x1FFF)) {//8.192 nodos
	if(tenemos_que_parar()){
		stop_search = true;
		return 0;
	} 		  
 }// nodos


//comprobamos las tablas hash

switch(probe_hash(Depth, &valorhash, beta, &hashmov, &tt_null_ok)){
	
   case Hash_ALPHA:		if(valorhash <= alpha) return valorhash;
						break;	
   case Hash_BETA:		if (valorhash >= beta) return valorhash;
						break;				
   case Hash_EXACT:		if (!nodo_pv ) return valorhash;
						break;
   default:break;
  }

cut_nodo = !nodo_pv
	       && !EnJaque
           && alpha > -VAL_WIN
           && beta <   VAL_WIN;


//* Si estamos en jaque o es un nodo de la variante principal,
//* no vamos a necesitar la evaluacion.

if(EnJaque) {
	if(Color == BLANCAS) evaluacion = MaterialBB - MaterialNN;
	else evaluacion = MaterialNN - MaterialBB;
	mejorando = false;
	goto BUCLE;
}

evaluacion = eval_hist[Profundidad] = evalua_posicion(alpha,beta);
mejorando = evaluacion >= eval_hist[Profundidad-2];


// Razoring Beta
if (Depth < (3 * UNPLY)
	&& hashmov.origen == 0
	&& cut_nodo
	&& fichas_BN
	&& evaluacion < beta - (500 + (32 * Depth))) {
	int beta_reducido = beta - (500 + (32 * Depth));
	int valor = qsearch(beta_reducido - 1, beta_reducido, 0);
	if (valor < beta_reducido) {
		Razor++;
		return valor;
	}
}

// Movimiento nulo estatico, si las condiciones son favorables,
// nos ahorramos el hacer el mov nulo dinamico, con mucho menos
// esfuerzo, solo cuando Depth esta cerca del horizonte (0).

if (Depth <= (3 * UNPLY) //was <= 3
	&& fichas_BN
	&& hacer_nulo
	&& cut_nodo
	&& evaluacion < VAL_WIN
	&& evaluacion - (150 * (Depth / UNPLY)) >= beta) {
	Estatic++;
	return evaluacion;
}
	
// MOVIMIENTO NULO	  
    //** En ajedrez esta prohibido pasar, pero con esta tecnica se hace
	//** una simulacion, que consiste en dejar que el contrario juegue 2
	//** veces seguidas y si no consigue nada ventajoso, quiere decir 
	//** que nuestra posicion es tan buena que podemos podar con seguridad.
	//** Aunque tiene el problema del "zugzwang", palabra alemana para
	//** referirse a una posicion en la que interesa que juegue el con -
	//** trario, y al darle el turno otra vez al contrario, con el MN,/
	//** ahora nuestra posicion nos parece mejor de lo que es en realidad.
	//** Afortunadamente estos casos se dan con poca frecuencia y cuando
	//** queda poco material. Esta totalmente prohibido hacer el MN 2 veces
	//** seguidas o cuando estamos en jaque, ademas de otras condiciones.
	
	  if (hacer_nulo  
		  && tt_null_ok
		  && (Depth >= (2*UNPLY) )
          && cut_nodo
		  && ((Color== BLANCAS && (MaterialBB -(PeonesBB * 100)) > VAL_A )|| 
		      (Color== NEGRAS  && (MaterialNN -(PeonesNN * 100)) > VAL_A)) 
		  && evaluacion >= beta) {

NulProb++;

// Guardamos los valores de la posicion, para luego restituirlos.
Valpaso = Alpaso;
Vhply = hply;
Vhash = hash;
historial[hply].capturada = 0;
historial[hply].origen = 0;
historial[hply].destino = 0;
if (Alpaso != 0)
     hash ^= hash_alpaso[Alpaso];
Alpaso = 0;
Color = -Color;
hash ^= hash_turno;
hply++;
fifty++;

// Adaptacion de la reduccion del mov nulo
// Tenemos que ir probando, no existe una formula universal
// que funcione igual de bien en todos los motores.

if(FichasBB > 2 && FichasNN > 2 ){
		R = 3 + (Depth > 5 * UNPLY ? (Depth/8) : 0);
		if (evaluacion-100 >= beta) R++;
}
else  R = 3 + (Depth/12);

 R *= UNPLY;
 nmscore = -search(-beta,-alpha,Depth-R,false,false);

//* Restauramos los valores  
hash = Vhash;
fifty--;
hply = Vhply;
Color = -Color; 
Alpaso = Valpaso;

if(nmscore >= beta){
	NulExito++;
			
    // Parece que no es aconsejable aceptar un mate
	// proveniente del movimiento nulo...??
	if (nmscore >= VALMATE-100) nmscore = beta;
	if (Depth < (6*UNPLY) ) return nmscore; 	//was 6
	// verificacion del movimiento nulo para evitar 
    // problemas con el zugzwang
	v_nulo = search(alpha, beta,Depth-R,false,EnJaque);
	if (v_nulo >= beta) return nmscore;
	
}
else {// Para no reducir, cuando tenemos amenaza de mate
	nulo_falla = true;
	if(nmscore < -VALMATE + 100)  
	   amenaza_mate = true;		
}

}//hacer_nulo  

//ProbCut
//Si tenemos una captura lo suficientemente buena y una bsqueda reducida devuelve un valor
//muy por encima de beta, podemos (casi) podar con seguridad el movimiento anterior.

    if (!nodo_pv
        &&  Depth >= 5 * UNPLY
        &&  abs(beta) < VALMATE - 128) {
		int value;
        int rbeta = min(beta + 300 - mejorando * 50, VAL_NUL);
		int probCutCount = 0;
	
		genera_todo();
		//genera_capturas();

        while((i = tomanextmov()) >= 0 && probCutCount < 3 ) {
			 MakeMove(i);
			 if(!es_legal()) {
				retrocede(); 
				continue;
			}
            probCutCount++;
			value =  -qsearch(-rbeta, -rbeta+1, 0); 
                
            if (value >= rbeta){
				if(Color == BLANCAS)	
				jaque = casilla_atacada(Pos_RB,NEGRAS);
				else jaque = casilla_atacada(Pos_RN,BLANCAS);
				value = -search(-rbeta, -rbeta+1,Depth-4*UNPLY,false,jaque);
			}
			retrocede();
            if (value >= rbeta) return value;
			
       }//while
    }// Probcut

    //Internal iterative deepening, Ultima revision 2019
  if (Depth >= 8 * UNPLY && (hashmov.origen == 0  && hashmov.destino == 0)){
		search(alpha, beta, Depth-(6*UNPLY),false,EnJaque);
		Get_hash_move(&hashmov);	
  }

//* Aqui ya tenemos la posibilidad de mirar si podemos hacer
//* futility, solo tenemos que hacerlo una vez, y nos valdra
//* para todos los movimientos, 

if(Depth <= 5*UNPLY &&
    !nodo_pv &&
	!amenaza_mate){		
		if(FichasBB + FichasNN <= 4)
			 futil_eval = evaluacion + futil_margin2[Depth-UNPLY];
		else futil_eval = evaluacion + futil_margin1[Depth-UNPLY];
			if(futil_eval < alpha) {
				 futil_ok = true;
			}
}

BUCLE:

 genera_todo();

//*** Mientras tengamos movimientos en la pila, los vamos sacando por orden, (segun el
//*** eval que les dimos al almacenarlos), lo ejecutamos internamente, y comprobamos 
//*** que sea un movimiento legal, es decir que no deje a su Rey en jaque. 

     BestEval = -VALMATE;
	 mov_legales = 0;
	
    while((i = tomanextmov()) >= 0) {

     MakeMove(i);
	 if(!es_legal()) {
		retrocede(); 
		continue;
	 }
	 //if (ListaMov[i].origen == excluded_mov.origen &&
	 //    ListaMov[i].destino == excluded_mov.destino) continue;
     mov_legales++;
	 Nodos++;

if(Color == BLANCAS)	
	  jaque = casilla_atacada(Pos_RB,NEGRAS);
 else jaque = casilla_atacada(Pos_RN,BLANCAS);

 extendido = 0;

//** EXTENSORES ultima modificacion FEBRERO 2020
//** Los extensores son una poderosa arma para los programas de ajedrez, sin ellos
//** su juego desmerecera bastante, la idea es la siguiente: si acabamos de hacer
//** una jugada prometedora, en esta lnea en concreto nos extendemos un ply, es
//** decir miraremos una jugada ms que en las dems lneas y cuando terminemos de
//** analizar la variante, puede que gracias a los extensores hayamos visto 5  6
//** jugadas ms que en el resto de variantes. 

 if(jaque) { 
		 // Si se da jaque al mover el Rey es jaque a la descubierta
		if(abs(contenido[ListaMov[i].destino]) == R_B) extendido = (UNPLY) ;
		// Si con una captura buena o igualada, es poco probable que perdamos material.
		else if(ListaMov[i].capturada > 0 && (ValFicha2[abs(contenido[ListaMov[i].destino])] <= 
			ValFicha2[ListaMov[i].capturada])) extendido = (UNPLY) ;
		// Si movemos un peon, pero no es el que da jaque, tambien es jaque a la descubierta
		else if(contenido[ListaMov[i].destino] == P_B && contenido[ListaMov[i].destino + 9] != R_N &&
			contenido[ListaMov[i].destino + 11] != R_N) extendido = (UNPLY) ;
		else if(contenido[ListaMov[i].destino] == P_N && contenido[ListaMov[i].destino - 9] != R_B &&
			contenido[ListaMov[i].destino - 11] != R_B) extendido = (UNPLY) ;
		// Cerca del horizonte
		//else if(Depth <= 4 ) extendido = (UNPLY) ;

		else {
			retrocede();
			if(see(ListaMov[i].origen,ListaMov[i].destino) >= 0) extendido = (UNPLY) ;
            MakeMove(i);
		}
		if(extendido) Ext_jaque++;
 } // jaque

 else if(Depth <= 9*UNPLY || nodo_pv){
		// Extenso de enroque	
		if(ListaMov[i].enroquetipo > 0)extendido = (UNPLY); 
		// Extensor de Peon 7
		else if(abs(contenido[ListaMov[i].destino]) == P_B &&
			(FILA[ListaMov[i].destino] == 7 || FILA[ListaMov[i].destino] == 2)) 
			extendido = UNPLY; 
		//Entrando en un final de peones
		else if(FichasBB == 0 && FichasNN == 0 &&
			ListaMov[i].capturada > P_B){
				extendido = (UNPLY);}
  } //Depth <= 9*UNPLY || nodo_pv


 if(extendido) Extensores++;

 next_depth = (Depth - UNPLY) + extendido;
 cut = false;

 if(!EnJaque && 
	!jaque && //En algunas versiones, no siempre es extensor
	!amenaza_mate &&
	 mov_legales > 1 &&
	!extendido &&
	Eval_Last_Move < max_good_mov &&
	BestEval > -VALMATE+Profundidad &&
	ListaMov[i].enroquetipo == NO_ENROQUE &&
    ListaMov[i].promocion == 0 &&
	!avance_peligroso(ListaMov[i].destino))
	  cut = true;
 

//****** FUTILITY MOVE PRUNING ***********

if(Depth <= 7*UNPLY && // WAS 7
   cut &&
   !nodo_pv){
  
	if(futil_ok){// &&
	 //  !avance_peligroso(ListaMov[i].destino)){
			Futil++;
			BestEval = Max(BestEval, futil_eval);
			retrocede(); 
			continue;
	}

	// Basado en el numero de movimientos vistos
	// Nuevo en la version 1.47.
	if(mov_legales > FutilityMoveCount[Depth] && 
		!nulo_falla &&
		Eval_Last_Move < max_good_mov/10){// &&
		//!avance_peligroso(ListaMov[i].destino)){
			//Prueba++;
			retrocede(); 
			continue;
	}

	// Cerca del horizonte, los movimientos que parecen perder 
	// material, incluido en la version 1.66
	if(next_depth <= 5*UNPLY && // was 4
		abs(contenido[ListaMov[i].destino]) != R_B &&
		//abs(contenido[ListaMov[i].destino]) >= C_B &&
		see_after(i) < 0) {
		//Prueba++;
			retrocede(); 
			continue;
	} 

}// Futility

 //*** LMR*****************************
 //*** Intentamos hacer una reduccion de los movimientos menos prometedores, es lo
 //*** contrario de los extensores, para poder hacerlo se tienen que dar ciertas
 //*** condiciones, cuantas menos condiciones mas rapido, pero menos fiable.

 lmr_reduce = 0;	
 solo_peones = (FichasBB == 0 && FichasNN == 0);
 rey_solo = (FichasBB == 0 && PeonesBB == 0) || (FichasNN == 0 && PeonesNN == 0);

if(mov_legales == 1 ) //El primer movimiento sin reduccin	
    eval = -search(-beta,-alpha,next_depth,true,jaque);

else {
	  dofull = true;
      if(// cut &&
		//  !EnJaque && 
		  !jaque && 
		 // !extendido &&
		  ListaMov[i].capturada == 0 &&
          Depth >= (3*UNPLY) && //was 3
		  mov_legales > 2 &&
		  !solo_peones &&
		  !rey_solo &&
		  !avance_peligroso(ListaMov[i].destino)){

			  LMR++;
              lmr_reduce = lmr_red[Min(31, Depth/2)][Min(63,  mov_legales)] * UNPLY;
			 // if (EnJaque && abs(contenido[ListaMov[i].destino]) == R_B) lmr_reduce++;
              eval = -search(-alpha-1,-alpha,next_depth-lmr_reduce,true,jaque);
              dofull = (eval > alpha);
      }
      if (dofull) {
          eval = -search(-alpha-1,-alpha,next_depth,true,jaque);
			if(eval > alpha && eval < beta)
			eval = -search(-beta,-alpha,next_depth,true,jaque);
      }
}

	retrocede(); 


//** Si se nos acaba el tiempo, paramos de ver movimientos
   if (stop_search == true) return 0;
		
   if(eval > BestEval) {  
	 BestEval = eval; 
	
     bestmove.origen  = ListaMov[i].origen;
     bestmove.destino = ListaMov[i].destino;

	 if(BestEval > alpha) { 
		
		 good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino] += (Depth/2)*(Depth/2);
		 if(good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino] > max_good_mov )
			 max_good_mov = good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino];
		 if (max_good_mov > MAX_HIST) {

                    int origen,destino;
					max_good_mov >>=2;
					for (origen = A1; origen < H9; origen++)
						for (destino = A1;destino < H9;destino++){
							good_mov[0][origen][destino] >>= 2;
							good_mov[2][origen][destino] >>= 2;
						}// for
		 }//max_good_mov > MAX_HIST
		 
        if(BestEval >= beta) {
	        
//*** Hemos encontrado una fuerte jugada, y la recordaremos como matekiller o
//*** como killer, por si nos la volvemos a encontrar en otra variante. La 
//*** ejecutaremos con prioridad, pues lo normal es que si una jugada es fuerte,
//*** en una posicion, lo siga siendo en otra combinacion de jugadas
	
			//** Si amenaza mate, la recordamos como matekiller
            if(BestEval > (VALMATE-100)){
                matekiller[Profundidad].origen =  ListaMov[i].origen;
				matekiller[Profundidad].destino = ListaMov[i].destino;
			}
			//** Si es un captura, o una promocion a Dama, no hace falta 
			//** recordarla, pues ya tienen una prioridad muy elevada;
			//** de lo contrario la guardamos como movimiento killer
			else 
			if(ListaMov[i].capturada == VACIO &&
			   ListaMov[i].promocion < D_B  &&
               // para no perder killer2
			  ( ListaMov[i].origen != killer1[Profundidad].origen ||
			   ListaMov[i].destino != killer1[Profundidad].destino)
			   ){

			killer2[Profundidad] = killer1[Profundidad];
			killer1[Profundidad].origen = ListaMov[i].origen;
			killer1[Profundidad].destino = ListaMov[i].destino;
			}
  
			store_hash(Depth,BestEval, Hash_BETA, bestmove);
  
			return BestEval;
			
		}//BestEval > beta

        ActVarPrincipal(i);
	    alpha = BestEval;  
		hash_flag = Hash_EXACT;
		}//BestEval > alpha

      }//eval > Besteval
   }//while


   //** Si no hay movimientos legales,o son tablas o es mate.
   if(mov_legales == 0){
	   if(EnJaque == false) return 0;	
       else return -VALMATE+Profundidad+1;
	 }

   store_hash(Depth,BestEval, hash_flag, bestmove);
   return BestEval;

} //search

//*************************************************

int root_search(int alpha,int beta,int Depth)
{
   int   eval,BestEval;
   int   valorhash;
   int   hash_flag = Hash_ALPHA;
   int   mov_legales,i;
   int   next_depth;
   bool  nodo_pv =  ((beta - alpha) > 1);
   bool  EnJaque      = false;
   bool  jaque        = false;
   bool  extendido    = false;
   
tipomov bestmove = nomove;
VarPrinc[Profundidad][Profundidad].origen=0;	

//** Comprobamos si estamos en jaque, 
 if(Color == BLANCAS)
	  EnJaque = casilla_atacada(Pos_RB,NEGRAS);
 else EnJaque = casilla_atacada(Pos_RN,BLANCAS);

 probe_hash(Depth, &valorhash, beta, &hashmov, &jaque);

 BestEval = -VALMATE;
 genera_todo();

//*** Mientras tengamos movimientos en la pila, los vamos sacando por orden, (segun el
//*** eval que les dimos al almacenarlos), lo ejecutamos internamente, y comprobamos 
//*** que sea un movimiento legal, es decir que no deje a su Rey en jaque. 
    
	 mov_legales = 0;
	 
     while((i = tomanextmov()) >= 0) {

     MakeMove(i);
	 if(!es_legal()) {
		retrocede(); 
		continue;
	 }
				
     mov_legales++;
	 Nodos++;
 if(Color == BLANCAS)	
	  jaque = casilla_atacada(Pos_RB,NEGRAS);
 else jaque = casilla_atacada(Pos_RN,BLANCAS);

 //** Extensor de jaque, este extensor es obligado
	 if(jaque == true )  extendido = (UNPLY) ;
     else extendido = 0;
 
     next_depth = (Depth - UNPLY) + extendido;
 
 //*** Intentamos hacer una reduccion de los movimientos menos prometedores, es lo
 //*** contrario de los extensores, para poder hacerlo se tienen que dar ciertas
 //*** condiciones, cuantas menos condiciones mas rapido, pero menos fiable.
  
     
if(mov_legales == 1 ) //El primer movimiento sin reduccin	
	eval = -search(-beta,-alpha,next_depth,true,jaque);
	 
else { //intentamos reducir

//LMR:	 Reduccion de los ultimos movimientos
if( Depth >= (3*UNPLY) && //was 2
    !extendido  && 	
	!EnJaque &&	
	ListaMov[i].enroquetipo == NO_ENROQUE &&
    ListaMov[i].promocion == 0  && 
	mov_legales >= 4 &&	// was 8
	Eval_Last_Move < max_good_mov &&
	!avance_peligroso(ListaMov[i].destino)){
   
	int lmr_reduce = lmr_red[Min(31, Depth/2)][Min(63,  mov_legales)] * UNPLY;
	
	LMR++;
	eval = -search(-alpha-1,-alpha,next_depth-lmr_reduce,true,jaque);	
}
	   // Nos aseguramos de ver todas las jugadas
	   else eval = alpha +1;
		 if(eval > alpha){
            eval = -search(-alpha-1,-alpha,next_depth,true,jaque);
            if(eval > alpha && eval < beta)
            eval = -search(-beta,-alpha,next_depth,true,jaque);
			}
	   }//else    

	retrocede(); 

//** Si se nos acaba el tiempo, paramos de ver movimientos
   if (stop_search == true) break;
		
   if(eval > BestEval) {  
	 BestEval = eval; 

     bestmove.origen = ListaMov[i].origen;
     bestmove.destino = ListaMov[i].destino;

	 if(BestEval > alpha) {  
         good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino] += Depth/2;//was /UNPLY
		 if(good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino] > max_good_mov )
			 max_good_mov = good_mov[Color+1][ListaMov[i].origen][ListaMov[i].destino];				
				
        if(BestEval >= beta) {
	        
//*** Hemos encontrado una fuerte jugada, y la recordaremos como matekiller o
//*** como killer, por si nos la volvemos a encontrar en otra variante. La 
//*** ejecutaremos con prioridad, pues lo normal es que si una jugada es fuerte,
//*** en una posicion, lo siga siendo en otra combinacion de jugadas
			
			//** Si amenaza mate, la recordamos como matekiller
            if(BestEval > (VALMATE-100)){
                matekiller[Profundidad].origen =  ListaMov[i].origen;
				matekiller[Profundidad].destino = ListaMov[i].destino;
			}
			//** Si es un captura, o una promocion a Dama, no hace falta 
			//** recordarla, pues ya tienen una prioridad muy elevada;
			//** de lo contrario la guardamos como movimiento killer
			else 
			if(ListaMov[i].capturada == VACIO &&
			   ListaMov[i].promocion < D_B &&
			   // para no perder killer2
			   (ListaMov[i].origen != killer1[Profundidad].origen ||
			    ListaMov[i].destino != killer1[Profundidad].destino)
			   ){

			killer2[Profundidad] = killer1[Profundidad];
			killer1[Profundidad].origen = ListaMov[i].origen;
			killer1[Profundidad].destino = ListaMov[i].destino;
			}

store_hash(Depth,BestEval, Hash_BETA, bestmove);
  
			return BestEval;
			
		}//BestEval > beta

        ActVarPrincipal(i);
	    alpha = BestEval; 
		hash_flag = Hash_EXACT;
		}//BestEval > alpha

      }//eval > Besteval
   }//while
if (stop_search == true) return beta;

   //** Si no hay movimientos legales,o son tablas o es mate.
   if(mov_legales == 0){
	   if(EnJaque== false) return 0;	
       else return -VALMATE+Profundidad+1;
	 }

store_hash(Depth,BestEval, hash_flag, bestmove);
  
   return BestEval;

} //root_search



//* BUSCANDO TRANQUILIDAD, esta rutina es parte de la busqueda alfa/beta,
//* que con el tiempo se ha sofisticado,(no es nuestro caso) al extremo 
//* que necesita su propio espacio.

//* De hecho el programa visita mas veces esta rutina que search(); debido 
//* a que siempre le dedica la misma atencion, independientemente de que se
//* trate del ply 1 o del ply 20.

//* Que es lo que pretende ?, encontrar una posicion lo suficientemente
//* tranquila para que la evaluacion sea fiable. El bando al que le toca
//* mover, puede decidir, dejarlo como esta, si la posicion es aceptable
//* (evaluacion >= beta), o seguir capturando hasta conseguir otra posicion
//* mas favorable.

//* Como lo hace ?, generando solo las capturas (y promocion a Dama en
//* algunos casos); las capturas hay que ordenarlas siguiendo el sistema
//* MVV/LVA, capturar la pieza mas valiosa, con la de menos valor, pero
//* dando prioridad a la capturada, es decir DxD tiene prioridad sobre PxT;
//* esto no quiere decir que sea mejor captura, que no lo sabemos, pero el 
//* beneficio que se obtiene es grande, ya que las ramas del arbol que hay
//* que analizar se reducen drasticamente, conforme desparecen del tablero
//* las piezas pesadas.

//* Tenemos que decidir, si comprobamos los jaques o no, algunos programadores
//* lo hacen y otros no; los que lo hacen, que son mayoria, utilizan un
//* generador de movimiento especial llamado evasion de jaques, que solo 
//* genera los movimientos que neutralizan el jaque.
//* En esta version se utiliza un sistema intermedio, se comprueban los jaques
//* pero solo para no podar. Tambien utilizamos el evaluador estatico de 
//* intercambios de fichas see(), para podar las malas capturas reales, se 
//* puede perder algo, pero raramente este tipo de captura mejora el 
//* rendimiento global.

//* Ultima revision, version 1.47

int qsearch(int alpha,int beta,int Depth){

	int i;
    int value = 0;
	int best_value = -VALMATE;
	int legales = 0;
	bool final;

    Nodos++;

// Solo si venimos de search(), es posible que se
// repita la posicion, puesto que no generamos 
// movimientos de evasion.
if( Depth >= 0 && repeticion()) return 0;

// Si hemos llegado a la profundidad maxima, salimos
if(Profundidad >= PROF_MAXIMA){
	return evalua_posicion(alpha,beta);
}

//Comprobamos si aun queda tiempo
if (!(Nodos & 0x1FFF)) {//cada 8.192 nodos
    if(tenemos_que_parar()){
		stop_search = true;
		return 0;
	} 		  
 }// nodosq

	 best_value = evalua_posicion(alpha,beta);
     if(best_value >= beta) return best_value; 
     if(best_value > alpha) alpha = best_value;

 VarPrinc[Profundidad][Profundidad].origen = 0;

 genera_capturas();

 if (FichasBB > 0 && FichasNN > 0 &&
		PeonesBB > 0 && PeonesNN > 0){
		final = false;
	}	
	else final = true;


	while((i=tomanextmov())>=0) {
		//* Miramos si se reunen los requisitos necesarios, para
		//* no hacer esta captura
		
		if (ListaMov[i].promocion == 0) {

			if (!final &&
				best_value + 100 + ValFicha[ListaMov[i].capturada] <= alpha) {
				//Prueba++;
				continue;
			}
			
			if(ValFicha2[abs(contenido[ListaMov[i].origen])] >
			   ValFicha2[abs(contenido[ListaMov[i].destino])]){

					if(peon_defiende(ListaMov[i].origen, ListaMov[i].destino))	continue;
					if(see(ListaMov[i].origen,ListaMov[i].destino) < 0)         continue;
			}
		}
		
     MakeMove(i);
	 if(!es_legal()) {
         retrocede(); 
         continue;
	 }

 legales++;

value = -qsearch(-beta,-alpha,Depth-1);
 retrocede();


if (value > best_value) {
		if (value > alpha) { 
			if (value >= beta) return beta;
			ActVarPrincipal(i);	
			alpha = best_value; 
		}//best_score > alpha
		best_value = value;
}//score > best_score

} //while
 
return best_value;

} // Qsearch()

//* Para no podar o hacer LMR, si la jugada es un avance
//* de peon pasado a territorio enemigo.
//* Tal cual esta, es para utilizar despues de hacer el movimiento.

__forceinline bool avance_peligroso(int destino){

if (contenido[destino] == P_B){ 
	if(FILA[destino] == 7) 
		return true;
	else if(FILA[destino] == 6 &&
	    contenido[destino +10] != P_N &&
		contenido[destino + 9] != P_N &&
		contenido[destino +11] != P_N)
		return true;
/*	else if(FILA[destino] == 5 &&
		(MaterialNN -(PeonesNN * 100)) < VAL_D &&
	    contenido[destino +10] != P_N &&
		contenido[destino + 9] != P_N &&
		contenido[destino +11] != P_N &&
		contenido[destino +20] != P_N &&
		contenido[destino +19] != P_N &&
		contenido[destino +21] != P_N)
		return true;*/
	else return false;
}// white

if (contenido[destino] == P_N){ 
	if(FILA[destino] == 2) 
		return true;
	else if(FILA[destino] == 3 &&
		contenido[destino -10] != P_B &&
		contenido[destino - 9] != P_B &&
		contenido[destino -11] != P_B)
		return true;
	/*else if(FILA[destino] == 4 &&
		(MaterialBB -(PeonesBB * 100)) < VAL_D &&
	    contenido[destino -10] != P_B &&
		contenido[destino - 9] != P_B &&
		contenido[destino -11] != P_B &&
		contenido[destino -20] != P_B &&
		contenido[destino -19] != P_B &&
		contenido[destino -21] != P_B)
		return true;*/
	else return false;
}
return false;
}

// Ultima revision agosto 2012
__forceinline bool tenemos_que_parar() {

// Se nos acaba el tiempo ?
if(GetTime() >= stop_time ){ 
	 // Si estamos analizando en el tiempo del contrario,
	 // triplicamos el tiempo, no poner limite podria ser
	 // peligroso
	 if(en_tiempo_contrario == true ){
		if(GetTime() >= (stop_time + (maxtiempo*2)) )
			return true;
	 }
	 else {
		// Si estamos proximo a un control de tiempo, o
		// aun estamos viendo el primer movimiento de inicio y
		// no tenemos problemas, paramos
		if(quedan <= 4 || (Var_Principal && !problem ))	
			return true;
		// En otro caso le damos el doble de tiempo
		else if(GetTime() >= (stop_time + maxtiempo) ) 
			return true;
	 }
return false;
}//(GetTime

// Nos llega un comando de WinBoard ?				
if(wboard && CheckInput()){
	if(en_tiempo_contrario == true ) return true;
		else {
		char linea[256], comando[256];
		fgets(linea, 256, stdin);
		sscanf_s(linea, "%s", comando, (unsigned)_countof(comando));
			if (strcmp(comando, "exit") == 0 ||
				strcmp(comando, "?") == 0 ){ 
				return true;
			}	 				 
		}
}//winboard

// Nos llega un comando en modo consola ?
if (!wboard && _kbhit()) {
    return true;;
		}
	return false;
}// tenemos

// Utilizar solo con movimientos ordinarios, no promocion,
// no captura, no enroque.
__forceinline int see_after(int i) {
	int valor = -1;
	    //Retrocedemos el movimiento, para poder usar see()
		contenido[ListaMov[i].origen] = contenido[ListaMov[i].destino];
		contenido[ListaMov[i].destino] = 0;
		Color = -Color;
		valor = see(ListaMov[i].origen,ListaMov[i].destino);
		//Restablemos el movimiento
		contenido[ListaMov[i].destino] = contenido[ListaMov[i].origen];
		contenido[ListaMov[i].origen] = 0;
		Color = -Color;
		return valor;
}//see_after
