

//*** Ultima visita invierno 2017-2018 ***

#define VAL_FICHAS_INICIO      VAL_D + (2*(VAL_T+VAL_A+VAL_C))
#define VAL_FICHAS_SUFICIENTE  VAL_D + VAL_T + VAL_A + VAL_A
#define VAL_FICHAS_FINAL       2*(VAL_T + VAL_A)

// Bonus por acosar al rey contrario
static const int  TROPISMO_FICHA[8] = 
{0,  5, 15, 10,  5,  0,  0,  0};

static const int  TROPISMO_DAMA[8] = 
{0,  0, 20, 20, 15,  5,  0,  0};

static const int POCO_DESARROLLO[8] = {
  0, -5, -20, -35, -50, -65, -80, -100, 
};

//Ajuste del valor de la torre dependiendo del num de peones
static const int AJUSTE_T[10] = 
{60, 48, 36, 24, 12, 0,-12,-24,-36, 0};

//Ajuste del valor del caballo dependiendo del num de peones
static const int  AJUSTE_C[10] = 
{-30, -24, -18, -12, -6,  0,  6, 12, 18, 0};


// bonus, castigo, movilidad fichas
static const int knight_mov_mg[9] =  {-16, -8, 0, 4, 8, 16, 24, 26, 28};
//static const int knight_mov_eg[9] =  {-16, -8, 0, 4, 8, 16, 24, 26, 28};
static const int bishop_mov_mg[16] = {-20, -10, -5, 0, 10, 20, 30, 40, 50, 52, 54, 56, 58, 60, 60, 60};
//static const int bishop_mov_eg[16] = {-20, -10, -5, 0, 10, 20, 30, 40, 50, 52, 54, 56, 58, 60, 60, 60};
static const int rook_mov_mg[16] = {-16, -8, -4, 0, 4, 8, 12, 14, 16, 18, 20, 22, 22, 22, 22, 22};
static const int rook_mov_eg[16] = {-32, -16, -8, 0, 8, 16, 24, 32, 36, 40, 44, 48, 52, 56, 56, 56};
static const int queen_mov_mg[32] = {-16, -8, -6, -4, -2, 0, 2, 4, 6, 8, 10, 12, 14, 14, 14, 16, 16, 16, 16, 18, 
	18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18, 18};
static const int queen_mov_eg[32] = {-32, -16, -12, -6, 0, 4, 8, 16, 10, 24, 28, 28, 28, 28, 30, 30, 30, 
	30, 32, 32, 32, 32, 34, 34, 34, 34, 34, 34, 34, 34, 34, 34};


/*int Bonus_Counter_Atac [] = {  0,  8,  13,  21, 30, 40, 50, 60, 70, 80,
                  100,125,150,175,200,225,250,275,300,325,
                  350,375,400,425,450,475,500,525,550,575, 
                  600,600,600,600,600 };*/

int Bonus_Counter_Atac [] = {  0, 8,  13, 21, 34, 56, 90, 146,
	              200,250,300,350,400,450,500,550, 
                  600,600,600,600,600,600,600,600,600,600 };
int desarrolloB;
int desarrolloN;
int ColorAlfilB;
int ColorAlfilN;
int atacantesB, atacantesN;
int ataquesB, ataquesN;

const int Inc_Atac_Al_RB[5]  = {-1, 1, 9, 10, 11};
const int Inc_Atac_Al_RN[5]  = {-1, 1,-9,-10,-11};
	
int evalua_seguridad_RB() {	
int columna = COLUMNA[Pos_RB];
int score = 0;

		// Peones amigos protegen
		if(columna < 4) { // < col_D
			if     (contenido[C2] == P_B) score += 2;
			else if(contenido[C3] == P_B) score -= 4;
			else score -= 8;
				
			if     (contenido[B2] == P_B) score += 4;
			else if(contenido[B3] == P_B){
				 if(contenido[B2] == A_B && contenido[A2] == P_B) score += 8;
				 else score -= 8;
			}
			else score -= 16;
			
			if     (contenido[A2] == P_B) score += 4;
			else if(contenido[A3] == P_B) score -= 8;
			else score -= 16;
				
			// Peones contrarios atacan, mismo enroque 
		if(abs(columna - COLUMNA[Pos_RN]) <=1)  {
			if(contenido[A3] == P_N) score -= 8;
			else if(contenido[A4] == P_N) score -= 4;
			if(contenido[B3] == P_N) score -= 8;
			else if(contenido[B4] == P_N) score -= 4;
		}

		// Peones contrarios atacan, enroque diferente
		//if(enrocado_B && enrocado_N &&
		  if( abs(columna - COLUMNA[Pos_RN]) > 2)  {
			if(contenido[C3] == P_N) score -= 16;
			else if(contenido[C4] == P_N) score -= 8;
			else if(contenido[C5] == P_N) score -= 4;
			if(contenido[B3] == P_N) score -= 24;
			else if(contenido[B4] == P_N) score -= 16;
			else if(contenido[B5] == P_N) score -= 8;
			if(contenido[A3] == P_N) score -= 24;
			else if(contenido[A4] == P_N) score -= 16;
			else if(contenido[A5] == P_N) score -= 8;
			}
		} // col < 4
				
		else if(columna > 6) {//> col_E
			if(contenido[F2] == P_B) score += 2;
			else if(contenido[F3] == P_B) score -= 4;
			else score -= 8;
			
			if(contenido[G2] == P_B)score += 4;
			else if(contenido[G3] == P_B){ 
			     if(contenido[G2] == A_B && contenido[H2] == P_B ) score += 16;
				 else score -= 8;
			}
			else score -= 16;

			if(contenido[H2] == P_B) score += 4;
			else if(contenido[H3] == P_B) score -= 8;
			else score -= 16;

			// Peones contrarios atacan, mismo enroque 
		if(abs(columna - COLUMNA[Pos_RN]) <=1)  {
			if(contenido[H3] == P_N) score -= 8;
			else if(contenido[H4] == P_N) score -= 4;
			if(contenido[G3] == P_N) score -= 8;
			else if(contenido[G4] == P_N) score -= 4;
		}
			
			// Peones contrarios atacan, enroques diferentes
		//if(enrocado_B && enrocado_N &&
		  if( abs(columna - COLUMNA[Pos_RN]) > 2)  {
			if(contenido[F3] == P_N) score -= 18;
			else if(contenido[F4] == P_N) score -= 12;
			else if(contenido[F5] == P_N) score -= 8;
			if(contenido[G3] == P_N) score -= 32;
			else if(contenido[G4] == P_N) score -= 24;
			else if(contenido[G5] == P_N) score -= 12;
			if(contenido[H3] == P_N) score -= 32;
			else if(contenido[H4] == P_N) score -= 24;
			else if(contenido[H5] == P_N) score -= 12;

			}
		}// col > 6
		
			
		//Columna abierta cerca del Rey, tanto si esta 
		//enrocado como si no lo esta
		
		//misma columna
		if(Fila_Ultimo_PeonN[columna] == 1 && 
		   Fila_Ultimo_PeonB[columna] == 8)   score -= 24;
		   
		//columna de la izquierda 
		else if(columna > 1 && Fila_Ultimo_PeonN[columna-1] == 1 &&
			Fila_Ultimo_PeonB[columna-1] == 8) score -= 16;
		   
		//columna de la derecha
		else if(columna < 8 && Fila_Ultimo_PeonN[columna+1] == 1 &&
			Fila_Ultimo_PeonB[columna+1] == 8) score -= 16;
		   
		score *= Valor_FichasN;
		score /= VAL_FICHAS_INICIO;
		return score;
	}



int evalua_seguridad_RN() {
		
int columna = COLUMNA[Pos_RN];
int score = 0;

		// Peones amigos protegen
		if(columna < 4) {
			if(contenido[C7] == P_N) score += 2;
			else if(contenido[C6] == P_N) score -= 4;
			else score -= 8;

			if(contenido[B7] == P_N) score += 4;
			else if(contenido[B6] == P_N) {
			     if(contenido[B7] == A_N && contenido[A7] == P_N) score += 8;
				 else score -= 8;
			}
			else score -= 16;
			
			if(contenido[A7] == P_N) score += 4;
			else if(contenido[A6] == P_N) score -= 8;
			else score -= 16;

			// Peones contrarios atacan, mismo enroque 
		if(abs(columna - COLUMNA[Pos_RB]) <=1)  {
			if(contenido[A6] == P_B) score -= 8;
			else if(contenido[A5] == P_B) score -= 4;
			if(contenido[B6] == P_B) score -= 8;
			else if(contenido[B5] == P_B) score -= 4;
		}
		// Peones contrarios atacan, enroque diferente
		//if(enrocado_B && enrocado_N &&
		  if( abs(columna - COLUMNA[Pos_RB]) > 2)  {
			if(contenido[C6] == P_B) score -= 18;
			else if(contenido[C5] == P_B) score -= 12;
			else if(contenido[C4] == P_B) score -= 8;
			if(contenido[B6] == P_B) score -= 32;
			else if(contenido[B5] == P_B) score -= 24;
			else if(contenido[B4] == P_B) score -= 12;
			if(contenido[A6] == P_B) score -= 32;
			else if(contenido[A5] == P_B) score -= 24;
			else if(contenido[A4] == P_B) score -= 12;
			}
		}
		else if(columna > 5) {
			if(contenido[F7] == P_N)  score += 2;
			else if(contenido[F6] == P_N) score -= 4;
			else score -= 8;
			
			if(contenido[G7] == P_N)  score += 4;
			else if(contenido[G6] == P_N){ 
			     if(contenido[G7] == A_N && contenido[H7] == P_N)  score += 16;
				 else  score -= 8;
			}
			else score -= 16;
			
			if(contenido[H7] == P_N)  score += 4;
			else if(contenido[H6] == P_N)  score += 8;
			else score -= 16;

			// Peones contrarios atacan, mismo enroque 
		if(abs(columna - COLUMNA[Pos_RB]) <=1)  {
			if(contenido[G6] == P_B) score -= 8;
			if(contenido[G5] == P_B) score -= 4;
			if(contenido[H6] == P_B) score -= 8;
			if(contenido[H5] == P_B) score -= 4;
		}
			// Peones contrarios atacan, enroque diferente
		//if(enrocado_B && enrocado_N &&
		  if( abs(columna - COLUMNA[Pos_RB]) > 2)  {
			if(contenido[F6] == P_B) score -= 18;
			else if(contenido[F5] == P_B) score -= 12;
			else if(contenido[F4] == P_B) score -= 8;
			if(contenido[G6] == P_B) score -= 32;
			else if(contenido[G5] == P_B) score -= 24;
			else if(contenido[G4] == P_B) score -= 12;
			if(contenido[H6] == P_B) score -= 32;
			else if(contenido[H5] == P_B) score -= 24;
			else if(contenido[H4] == P_B) score -= 12;
			}
		}
		
		
		//Columna abierta cerca del Rey
		
		if(Fila_Ultimo_PeonB[columna] == 8 &&
			Fila_Ultimo_PeonN[columna] == 1)   score -= 24;
		   
		else if(columna > 1 && Fila_Ultimo_PeonB[columna-1] == 8 &&
			Fila_Ultimo_PeonN[columna-1] == 1) score -= 16;
		   
		else if(columna < 8 && Fila_Ultimo_PeonB[columna+1] == 8 &&
			Fila_Ultimo_PeonN[columna+1] == 1) score -= 16;
		   
		score *= Valor_FichasB;
		score /= VAL_FICHAS_INICIO;
		return score;
	}


int Desarrollo_B(){
int score = 0;

   // Peones centrales bloqueados 	
if(contenido[D2] == P_B && contenido[D3] != VACIO){
	score -= 20;
}
if(contenido[E2] == P_B && contenido[E3] != VACIO){
	score -= 20;
}

if (contenido[D4] == P_B && contenido[C2] == P_B && 
	contenido[C3] == C_B) {
	score -= 20;
  }

if(contenido[B2] == A_B) {
   if(contenido[C3] == P_B) score -= 10; //eg -= 20
   if(contenido[B3] == P_B && (contenido[A2] == P_B) || (contenido[C2] == P_B)){
	   score += 8;
	   if(enrocado_B && COLUMNA[Pos_RB] < col_d) score += 8;
   }
   if(contenido[D4] == P_N && (contenido[E5] == P_N) || (contenido[C5] == P_N)) score -= 20;
}

if(contenido[G2] == A_B) {
   if(contenido[F3] == P_B) score -= 10; //eg -= 20
   if(contenido[G3] == P_B && (contenido[H2] == P_B) || (contenido[F2] == P_B)){
	   score += 8;
	   if(enrocado_B && COLUMNA[Pos_RB] > col_e) score += 8;
   }
   if(contenido[E4] == P_N && (contenido[D5] == P_N) || (contenido[F5] == P_N)) score -= 20; 
}
if(enrocado_B == true) { 
	desarrolloB++; 
	score += 20;
}

if(contenido[B1] != C_B) desarrolloB++; 
if(contenido[C1] != A_B) desarrolloB++; 
if(contenido[F1] != A_B) desarrolloB++; 
if(contenido[G1] != C_B) desarrolloB++; 

// Tener un peon en E4 o D4, es bueno
if(contenido[D4] == P_B || contenido[E4] == P_B) 
score += 10;

// para evitar los gambitos de peon en la apertura
// if(ELO oponente > 2100){, estaria bien ?
 if((PeonesBB < PeonesNN) &&
	 (FichasBB == FichasNN)) score -= 40;

score += POCO_DESARROLLO[5-desarrolloB];
return score;
}

int Desarrollo_N(){
int score = 0;

// Peones centrales bloqueados 	
if(contenido[E7] == P_N && contenido[E6] != VACIO){
	score -= 20;
}
if(contenido[D7] == P_N && contenido[D6] != VACIO){
	score -= 20;
}

if (contenido[D5]== P_N && contenido[C7]== P_N && 
	contenido[C6]== C_N) {
	score -= 20;
  }

if(contenido[B7] == A_N) {
   if(contenido[C6] == P_N) score -= 10; //eg -= 20
   if(contenido[B6] == P_N && (contenido[A7] == P_N) || (contenido[C7] == P_N)){
	   score += 8;
	   if(enrocado_N && COLUMNA[Pos_RN] < col_d) score += 8;
   }
   if(contenido[D5] == P_B && (contenido[E4] == P_B) || (contenido[C4] == P_B)) score -= 20; 
}

if(contenido[G7] == A_N) {
   if(contenido[F6] == P_N) score -= 10; //eg -= 20
   if(contenido[G6] == P_N && (contenido[H7] == P_N) || (contenido[F7] == P_N)){
	   score += 8;
	   if(enrocado_N && COLUMNA[Pos_RN] > col_e) score += 8;
   }
   if(contenido[E5] == P_B && (contenido[D4] == P_B) || (contenido[F4] == P_B)) score -= 20; 
}

if(enrocado_N == true) { 
	desarrolloN++; 
	score += 20;
}

if(contenido[B8] != C_N) desarrolloN++;
if(contenido[C8] != A_N) desarrolloN++;
if(contenido[F8] != A_N) desarrolloN++;
if(contenido[G8] != C_N) desarrolloN++;

if(contenido[D5] == P_N || contenido[E5] == P_N) 
score += 10;

if((PeonesNN < PeonesBB) &&
	 (FichasBB == FichasNN)) score -= 40;

score += POCO_DESARROLLO[5-desarrolloN];
return score;
}


static int  Evalua_CaballoB_Atak(int pos) {
	int i,ca;
	int atak = 0, mov = 0, score = 0;

	for(i = 0; i < 8; i++) {
    ca = pos+Inc_Ca[i];
		if(es_casilla(ca)){
			// controla el centro
			score += control_centro[ca];
			// casilla vacia o ficha negra
			if(contenido[ca] <= VACIO) mov++;
			//si ataca casilla cercana al Rey contrario
			if(Distancia[ca][Pos_RN] <= 1) atak++;	
		}
   }//for
	if(atak > 0){
		ataquesB += atak;
		atacantesB++;
	}
	/*if(fase_final) return knight_mov_eg[mov] + score;
	else */return knight_mov_mg[mov] + score;
}// caballo b atak

static int  Evalua_CaballoB(int pos) {
	int i,ca;
	int atak = 0, mov = 0, score = 0;

	for(i = 0; i < 8; i++) {
    ca = pos+Inc_Ca[i];
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= VACIO) mov++;
		}
   }//for
/*if(fase_final) return knight_mov_eg[mov] + score;
	else*/ return knight_mov_mg[mov] + score;
}// caballo b 

static int  Evalua_CaballoN_Atak(int pos) {
	int i,ca;
	int atak = 0, mov = 0, score = 0;

	for(i = 0; i < 8; i++) {
		ca = pos+Inc_Ca[i];
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= VACIO) mov++;	
			if(Distancia[ca][Pos_RB] <= 1) atak++;	
		}
   }//for
	if(atak > 0){
		ataquesN += atak;
		atacantesN++;
	}
/*if(fase_final) return knight_mov_eg[mov] + score;
	else*/ return knight_mov_mg[mov] + score;
}

static int  Evalua_CaballoN(int pos) {
	int i,ca;
	int atak = 0, mov = 0, score = 0;

	for(i = 0; i < 8; i++) {
		ca = pos+Inc_Ca[i];
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= VACIO) mov++;	
		}
   }//for
/*if(fase_final) return knight_mov_eg[mov] + score;
	else*/ return knight_mov_mg[mov] + score;
}

static int Evalua_AlfilB_Atak(int pos) {
	int ca,atak = 0, mov = 0,score = 0;

	//Si caballo blanco,seguimos con rayos X
	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		mov++;
		score += control_centro[ca];
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
	//hemos salido del buque,porque la ultima casilla visitada,no esta vacia
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N ) mov++; // atacamos ficha negra
			// si estamos avanzando	(ca+9 y ca+11)
			if(contenido[ca] == P_B ){ //peon_bloquea_alfil
				// el peon que bloquea,tiene en frente un peon negro
				if(contenido[ca+10] == P_N) score -= 8; 
				else score -= 4; 
			}
			if(ca < A5) score -= 8;  //alfil no llega a campo contrario
		}	
	for (ca = pos+9;contenido[ca] == VACIO; ca+=9){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(Distancia [ca][Pos_RN] <= 1) atak++;
		if(contenido[ca] <= P_N ) mov++;
		if(contenido[ca] == P_B ){
			if(contenido[ca+10] == P_N) score -= 8; 
			else  score -= 4; 
		}
		if(ca < A5) score -= 8; 
	}
	for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	} 
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++;
		}	
	for (ca = pos-9;contenido[ca] == VACIO; ca-=9){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N ) mov++;
		}		 
	
	if(atak > 0){
		ataquesB += atak;
		atacantesB++;
	}
/*if(fase_final) return bishop_mov_eg[mov] + score;
else*/ return bishop_mov_mg[mov] + score;
}

static int Evalua_AlfilB(int pos) {
	int ca,atak = 0, mov = 0,score = 0;

	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		mov++;
		score += control_centro[ca];
	}
	//hemos salido del bucle,porque la ultima casilla visitada,no esta vacia
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N ) mov++; // atacamos ficha negra
			if(contenido[ca] == P_B ){ //peon_bloquea_alfil
				if(contenido[ca+10] == P_N) score -= 8; 
				else score -= 4; 
			}
			if(ca < A5) score -= 8;
		}	
	for (ca = pos+9;contenido[ca] == VACIO; ca+=9){
		score += control_centro[ca];
		mov++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(contenido[ca] <= P_N ) mov++;
		if(contenido[ca] == P_B ){
			if(contenido[ca+10] == P_N) score -= 8; 
			else  score -= 4; 
		}
		if(ca < A5) score -= 8; 
	}
	for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		score += control_centro[ca];
		mov++;
	} 
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N) mov++;
		}	
	for (ca = pos-9;contenido[ca] == VACIO; ca-=9){
		score += control_centro[ca];
		mov++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N ) mov++;
		}		 

/*if(fase_final) return bishop_mov_eg[mov] + score;
else*/ return bishop_mov_mg[mov] + score;
}

static int Evalua_AlfilN_Atak(int pos) {
	int ca,atak = 0, mov = 0,score = 0;

	for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(Distancia [ca][Pos_RB] <= 1) atak++;
		if(contenido[ca] >= P_B ) mov++;
		if(contenido[ca] == P_N ){
			if(contenido[ca-10] == P_B) score -= 8; 
			else score -= 4; 
		}
		if(ca >= A5) score -= 8;
	}	
	for (ca = pos-9;contenido[ca] == VACIO; ca-=9){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(Distancia [ca][Pos_RB] <= 1) atak++;
		if(contenido[ca] >= P_B ) mov++;
		if(contenido[ca] == P_N ){
			if(contenido[ca-10] == P_B) score -= 8; 
			else score -= 4; 
		}
		if(ca >= A5) score -= 8; 
	}
	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	} 
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(Distancia [ca][Pos_RB] <= 1) atak++;
		if(contenido[ca] >= P_B ) mov++;
	}	
	for (ca = pos+9;contenido[ca] == VACIO; ca+=9){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(Distancia [ca][Pos_RB] <= 1) atak++;
		if(contenido[ca] >= P_B ) mov++;
	}		 
	
	if(atak > 0){
			ataquesN += atak;
			atacantesN ++;
	}
/*if(fase_final) return bishop_mov_eg[mov] + score;
else*/ return bishop_mov_mg[mov] + score;
}

static int Evalua_AlfilN(int pos) {
	int ca,atak = 0, mov = 0,score = 0;

	for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		score += control_centro[ca];
		mov++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(contenido[ca] >= P_B ) mov++;
		if(contenido[ca] == P_N ){
			if(contenido[ca-10] == P_B) score -= 8; 
			else score -= 4; 
		}
		if(ca >= A5) score -= 8;
	}	
	for (ca = pos-9;contenido[ca] == VACIO; ca-=9){
		score += control_centro[ca];
		mov++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(contenido[ca] >= P_B ) mov++;
		if(contenido[ca] == P_N ){
			if(contenido[ca-10] == P_B) score -= 8; 
			else score -= 4; 
		}
		if(ca >= A5) score -= 8; 
	}
	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		score += control_centro[ca];
		mov++;
	} 
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(contenido[ca] >= P_B ) mov++;
	}	
	for (ca = pos+9;contenido[ca] == VACIO; ca+=9){
		
		mov++;
	}
	if(es_casilla(ca)){
		score += control_centro[ca];
		if(contenido[ca] >= P_B ) mov++;
	}	

/*if(fase_final) return bishop_mov_eg[mov] + score;
else*/ return bishop_mov_mg[mov] + score;
} // alfil negro

static int Evalua_TorreB_Atak(int pos) {
int ca;
int atak = 0,mov = 0, score = 0;

	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++; 
		}
	for (ca = pos+10;  contenido[ca] == VACIO; ca+=10){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++;
		}
	for (ca = pos-1; contenido[ca] == VACIO; ca-=1){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++;
		}
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RN] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++;
		}

	if(atak > 0){
			ataquesB += atak;
			atacantesB ++;
	}
	if(fase_final)	return (score + rook_mov_eg[mov]);
	else return (score + rook_mov_mg[mov]);
}

static int Evalua_TorreB(int pos) {
int ca;
int atak = 0,mov = 0, score = 0;

	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N) mov++; 
		}
	for (ca = pos+10;  contenido[ca] == VACIO; ca+=10){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RN] <= 1) atak++;
			if(contenido[ca] <= P_N) mov++;
		}
	for (ca = pos-1; contenido[ca] == VACIO; ca-=1){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N) mov++;
		}
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] <= P_N) mov++;
		}

	if(fase_final)	return (score + rook_mov_eg[mov]);
	else return (score + rook_mov_mg[mov]);
}

static int Evalua_TorreN_Atak(int pos) {
int ca;
int atak = 0,mov = 0, score = 0;

	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RB] <= 1) atak++;
			if(contenido[ca] >= P_B) mov++; 
		}
	for (ca = pos+10;  contenido[ca] == VACIO; ca+=10){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RB] <= 1) atak++;
			if(contenido[ca] >= P_B) mov++;
		}
	for (ca = pos-1; contenido[ca] == VACIO; ca-=1){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RB] <= 1) atak++;
			if(contenido[ca] >= P_B) mov++;
		}
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		score += control_centro[ca];
		mov++;
		if(Distancia [ca][Pos_RB] == 1) atak++;
	}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(Distancia [ca][Pos_RB] <= 1) atak++;
			if(contenido[ca] >= P_B) mov++;
		}

	if(atak > 0){
			ataquesN += atak;
			atacantesN ++;
	}
	if(fase_final)	return (score + rook_mov_eg[mov]);
	else return (score + rook_mov_mg[mov]);
}

static int Evalua_TorreN(int pos) {
int ca;
int atak = 0,mov = 0, score = 0;

	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= P_B) mov++; 
		}
	for (ca = pos+10;  contenido[ca] == VACIO; ca+=10){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= P_B) mov++;
		}
	for (ca = pos-1; contenido[ca] == VACIO; ca-=1){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= P_B) mov++;
		}
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		score += control_centro[ca];
		mov++;}
		if(es_casilla(ca)){
			score += control_centro[ca];
			if(contenido[ca] >= P_B) mov++;
		}
	if(fase_final)	return (score + rook_mov_eg[mov]);
	else return (score + rook_mov_mg[mov]);
}

static int Evalua_DamaB(int pos) {
int ca;
int mov = 0, score = 0;

 if(FILA[pos]== 7) score += 10; 
	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos-1;  contenido[ca] == VACIO; ca-=1){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos+10; contenido[ca] == VACIO; ca+=10){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
    for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos-9;  contenido[ca] == VACIO; ca-=9){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	for (ca = pos+9;  contenido[ca] == VACIO; ca+=9){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] < P_N) mov++;
		
	if(fase_final)	return (score + queen_mov_eg[mov]);
	else return (score + queen_mov_mg[mov]);
}


static int Evalua_DamaN(int pos) {
int ca;
int mov = 0, score = 0;

 if(FILA[pos]== 7) score += 10; 
	for (ca = pos-10; contenido[ca] == VACIO; ca-=10){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos-1;  contenido[ca] == VACIO; ca-=1){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos+10; contenido[ca] == VACIO; ca+=10){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos+1;  contenido[ca] == VACIO; ca+=1){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
    for (ca = pos-11; contenido[ca] == VACIO; ca-=11){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos-9;  contenido[ca] == VACIO; ca-=9){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos+11; contenido[ca] == VACIO; ca+=11){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	for (ca = pos+9;  contenido[ca] == VACIO; ca+=9){
		mov++;
		score += control_centro[ca];}
	if(contenido[ca] > P_B) mov++;
		
	if(fase_final)	return (score + queen_mov_eg[mov]);
	else return (score + queen_mov_mg[mov]);
}

static int Evalua_DamaB_Atak(int pos) {
	int score = 0, mov = 0,ataques = 0;
	int i,destino;
		for ( i = 0; i < 8; i++) {
			    destino = pos + Inc_Da[i];
				while ( contenido [destino] == VACIO ) {
					mov++;
		            score += control_centro[destino];
					if(Distancia[destino][Pos_RN] == 1) ataques++;
					destino += Inc_Da[i];
				}//while
				if(es_casilla(destino)){
				if(contenido[destino] < P_N) mov++;
				score += control_centro[destino];
				if(Distancia[destino][Pos_RN] <= 1) ataques++;
				}
				
		}//for
		if(ataques > 0){
			ataquesB += (ataques+1);// Bonus por ataque de la dama
			atacantesB++;
		}
	if(fase_final)	return (score + queen_mov_eg[mov]);
	else return (score + queen_mov_mg[mov]);
}

static int Evalua_DamaN_Atak(int pos) {
	int score = 0, mov = 0,ataques = 0;
	int i,destino;
	
		for ( i = 0; i < 8; i++) {
			    destino = pos + Inc_Da[i];
				while ( contenido [destino] == VACIO ) {
					mov++;
		            score += control_centro[destino];
					if(Distancia[destino][Pos_RB] == 1) ataques++;
					destino += Inc_Da[i];
				}//while
				if(es_casilla(destino)){
				if(contenido[destino] > P_B) mov++;
				score += control_centro[destino];
				if(Distancia[destino][Pos_RB] <= 1) ataques++;
				}
				
		}//for
		if(ataques > 0){
			ataquesN += (ataques+1);// Bonus por ataque de la dama
			atacantesN++;
		}
	if(fase_final)	return (score + queen_mov_eg[mov]);
	else return (score + queen_mov_mg[mov]);
}


int evalua_posicion(int alpha,int beta){
   int eval;
   int hscore;
   int i,x,casilla;
   int contador = 0;  
   int posevalb = 0;
   int posevaln = 0;
   int tempo_mg = 12, tempo_eg = 8;
   int Dif_Valor_Fichas;
   int Dif_Fichas_Menores; 
 
   bool B_PuedeGanar = false;
   bool N_PuedeGanar = false;
   bool solo_peones = false;
   bool solo_piezas = false;
   bool W_can_atak, B_can_atak;

fase_final = false;
desarrolloB = 0;
desarrolloN = 0;   
atacantesB    = 0; atacantesN    = 0;
ataquesB      = 0; ataquesN      = 0;
DB =  0; DN  = 0;
dist_para_coronarB = 8;
dist_para_coronarN = 8;


//* evaluamos el material
if(Color == BLANCAS) eval = MaterialBB - MaterialNN;
else                 eval = MaterialNN - MaterialBB;

Valor_FichasB = (MaterialBB -(PeonesBB * 100));
Valor_FichasN = (MaterialNN -(PeonesNN * 100));

//* Miramos en que fase de la partida estamos
if (Valor_FichasB <= VAL_FICHAS_FINAL &&
    Valor_FichasN <= VAL_FICHAS_FINAL){
    fase_final = true;
	if (Valor_FichasB == (VAL_D + VAL_A) || Valor_FichasB == (VAL_D + VAL_C))fase_final = false;
	else if (Valor_FichasN == (VAL_D + VAL_A) || Valor_FichasN == (VAL_D + VAL_C))fase_final = false;
}


//********** EVALUACION FASE FINAL ******************************
if(fase_final == true){

	if(PeonesBB > 0 ||
	  (Valor_FichasB >= VAL_T && 
	   Valor_FichasB != 2*VAL_C))
	   B_PuedeGanar = true;

    if(PeonesNN > 0 ||
	  (Valor_FichasN >= VAL_T && 
	   Valor_FichasN != 2*VAL_C))
	   N_PuedeGanar = true;

	if(!B_PuedeGanar && !N_PuedeGanar)
    return 0;

//Evaluacion corta / Lazy eval....
if((eval < alpha - VAL_T)|| (eval > beta + VAL_T)){
	   PosC++;
	   return eval;
}		

//*Probamos a ver si ya tenemos evaluada la posicion
hscore = probe_eval(Color);
if (hscore != -VALMATE){
	PosH++;
	return hscore;	
}

	//**** No hay peones ********
	if(PeonesBB == 0 && PeonesNN == 0){
		solo_piezas = true;
	
		//Si solo un bando tiene material
		if( MaterialBB + MaterialNN == abs(eval)){
			if(abs(eval) == VAL_A + VAL_C)
				return Eval_mate_alfil_caballo();
			else return ReySolitario();
		}
		if(FichasBB == 1 && FichasNN == 1)
			return Eval_ficha_ficha(Color);
	}// De 0 peones

	// Vale hay peones, pero comprobamos si se trata
	// de un final de solo un peon
	else if(FichasBB == 0 && FichasNN== 0){ 
		solo_peones = true;

		if ((PeonesBB == 0 && PeonesNN == 1)||
		(PeonesBB == 1 && PeonesNN == 0) ) {
		return EvaluaRPR(Color);	   
		}
	}// no fichas

	//** Miramos algunos casos especiales, evitaremos entrar si
	//** tenemos ventaja, o procuramos entrar si estamos inferior

	if (PeonesBB + PeonesNN == 1){

		// Tablas Alfil y Peon en columna de torre
		if((MaterialBB == VAL_A + VAL_P && MaterialNN == 0)||
			(MaterialNN == VAL_A + VAL_P && MaterialBB == 0))
			return Alfil_peon(Color);

		// Tablas Alfil y Peon contra Alfil diferente color
		if((MaterialBB == VAL_A + VAL_P && MaterialNN == VAL_A)||
			(MaterialNN == VAL_A + VAL_P && MaterialBB == VAL_A))
			 return AlfilPeon_Alfil(Color);

		// Tablas Dama contra Peon en 7, en columna A,H,C,o F
		if((MaterialBB == VAL_D && MaterialNN == VAL_P)||
			(MaterialNN == VAL_D && MaterialBB == VAL_P))
			return Dama_peon(Color);

		//* Torre y Peon contra torre, merece un tratamiento especial,
		//* ya que se da con bastante frecuencia, y es dificil ganar
		//* aun no implementado
		if((MaterialBB == VAL_T + VAL_P && MaterialNN == VAL_T)||
			(MaterialNN == VAL_T + VAL_P && MaterialBB == VAL_T))
			return RTP_RT();
		
	}// Un peon

  // ** Vale,no tenemos mas remedio que hacer la evaluacion completa.
 
init_peones();

   	PosL++;

   DamasB=TorresB=AlfilesB=CaballosB= 0;
   DamasN=TorresN=AlfilesN=CaballosN= 0;
   
//** Evaluacion fichas blancas, finales **
for (i = 0; i < Num_FiB; i++){
 
     casilla = Lista_FichasB[i]; 
	 switch(contenido[casilla]) {

case R_B:
	 // Centralizamos al Rey en los finales 
	 posevalb += wk_pcsq_eg[casilla];
	 //Oposicion con el rey contrario
	 if(FichasBB <= 1 && FichasNN <= 1 &&
	   ((abs(casilla-Pos_RN)==20)||
		(abs(casilla-Pos_RN)==2))) {
		  if(Color==BLANCAS)
		       posevalb -= 20;
		  else posevalb += 20;}
	 break;

case P_B:
     posevalb += EvaluaPeonBF(casilla);
	 break;

case C_B:
	CaballosB ++; 
	if(pn_controla(casilla)) posevalb -= 8; 
	 if(outpost[casilla] &&
		Fila_Ultimo_PeonN[COLUMNA[casilla]-1] < FILA[casilla] &&
	    Fila_Ultimo_PeonN[COLUMNA[casilla]+1] < FILA[casilla] ) {
		if(contenido[casilla-9] == P_B) posevalb += outpost[casilla];
		if(contenido[casilla-11] == P_B) posevalb += outpost[casilla];
	 }
     
	 posevalb += wn_pcsq_eg[casilla];
	 posevalb +=  Evalua_CaballoB(casilla);
	   
	 break;

case A_B:
     AlfilesB++;
	 ColorAlfilB = COLOR_CA[casilla];
	 if(pn_controla(casilla)) posevalb -= 8;
	// Alfil atrapado en septima
	if     (casilla == A6 && contenido[B5] ==  P_N) {posevalb  -= 50; break;}
    if(casilla == A7 && contenido[B6] ==  P_N) {posevalb  -= 150;break;}
    if(casilla == B8 && contenido[C7] ==  P_N) {posevalb  -= 150;break;}
	if(casilla == H6 && contenido[G5] ==  P_N) {posevalb  -= 50; break;}
    if(casilla == H7 && contenido[G6] ==  P_N) {posevalb  -= 150;break;}
    if(casilla == G8 && contenido[F7] ==  P_N) {posevalb  -= 150;break;}
	 posevalb += wb_pcsq_eg[casilla];
	 posevalb +=  Evalua_AlfilB(casilla);
	 break;

case T_B:
	 TorresB++;
	 if(pn_controla(casilla)) posevalb -= 12;
	 posevalb +=  Evalua_TorreB(casilla);
	 posevalb +=  wr_pcsq_eg[casilla];
	
	 // Torre en septima 
	 if(FILA[casilla]== fila_7){
		 if(FILA[Pos_RN]== fila_8) posevalb += 32;
		 else {
			 for(x= A7; x < H7; x += 1)
				 if(contenido[x] == P_N){ 
					 posevalb += 32;
					 break;
				 }
		 }
	 }
	 // Esta en columna semiabieta ?
	 if(Fila_Ultimo_PeonB[COLUMNA[casilla]] == no_wpawn_in_col){
		// en columna de la Dama o Rey contrario
        if(abs(COLUMNA[casilla] - COLUMNA[Pos_RN]) <= 1 ||
			  (COLUMNA[casilla] == COLUMNA[DN]))
			posevalb += 8;
		// La columna esta abierta ?
        if(Fila_Ultimo_PeonN[COLUMNA[casilla]] == no_bpawn_in_col)
			posevalb += 16;
			else posevalb += 8;
	 }
	
	 break;

case D_B:
     DamasB++; 
	 if(pn_controla(casilla)) posevalb -= 24;
	 if(FILA[casilla]== fila_7){
		if(FILA[Pos_RN]== fila_8) posevalb += 20;
			else posevalb += 10;
	 }// fila = 7	
	 posevalb += wq_pcsq_eg[casilla];
	 posevalb += Evalua_DamaB(casilla);
	 posevalb += TROPISMO_DAMA[Distancia[casilla][Pos_RN]];
	
	 break;

	 }// switz
  }//for 


//** Evaluacion fichas negras, finales **
  for (i = 0; i < Num_FiN; i++){

     casilla = Lista_FichasN[i]; 
	 switch(contenido[casilla]) {

case R_N: 
     // En los finales finales centralizamos el Rey 
	 posevaln += bk_pcsq_eg[casilla];
     //Oposicion con el rey contrario	
     if(FichasBB <= 1 && FichasNN <= 1 &&
     ((abs(casilla-Pos_RB)== 20)||
     (abs(casilla-Pos_RB)== 2))) {
		  if(Color == NEGRAS)
		       posevaln -= 20;
		  else posevaln += 20;
	       }// Oposicion
	    break;	

case P_N:	
     posevaln += EvaluaPeonNF(casilla);
	 break;

case C_N:   
	 CaballosN++;
	 if(pb_controla(casilla)) posevaln -= 8;
	 if(outpost[FLIP[casilla]] &&
		   Fila_Ultimo_PeonB[COLUMNA[casilla]-1] > FILA[casilla] &&
	       Fila_Ultimo_PeonB[COLUMNA[casilla]+1] > FILA[casilla] ){
			if(contenido[casilla+9] == P_N) posevaln += outpost[FLIP[casilla]];
			if(contenido[casilla+11] == P_N) posevaln += outpost[FLIP[casilla]];
	 }
	
	 posevaln += bn_pcsq_eg[casilla];
	 posevaln +=  Evalua_CaballoN(casilla);
	 break;

case A_N:
     AlfilesN++;
	 ColorAlfilN = COLOR_CA[casilla];
	 if(pb_controla(casilla)) posevaln -= 8;
	// Alfil atrapado
	if      (casilla == A3 && contenido[B4] == P_B ) {posevaln -= 50; break;}
	if (casilla == A2 && contenido[B3] == P_B ) {posevaln -= 150;break;}
    if (casilla == B1 && contenido[C2] == P_B ) {posevaln -= 150;break;}
	if (casilla == H3 && contenido[G4] == P_B ) {posevaln -= 50; break;}
    if (casilla == H2 && contenido[G3] == P_B ) {posevaln -= 150;break;}
    if (casilla == G1 && contenido[F2] == P_B ) {posevaln -= 150;break;}	 
	 posevaln +=  bb_pcsq_eg[casilla];
	 posevaln +=  Evalua_AlfilN(casilla);
     
	 break;

case T_N:
	 TorresN++;
	 if(pb_controla(casilla)) posevaln -= 12;
	 posevaln += br_pcsq_eg[casilla]; 
	 posevaln += Evalua_TorreN(casilla);
	 // Torre en septima
	 if(FILA[casilla]== 2){
		 if(FILA[Pos_RB]== 1) posevaln += 32;
		 else {
			 for(x= A2; x < H2; x += 1)
				 if(contenido[x] == P_B){ 
					 posevaln += 32;
					 break;
				 }
		 }
	 }
	 // Esta en columna semiabieta ?
	 if(Fila_Ultimo_PeonN[COLUMNA[casilla]] == no_bpawn_in_col){
		// en columna de la Dama o Rey contrario
        if(abs(COLUMNA[casilla] - COLUMNA[Pos_RB]) <= 1 ||
			  (COLUMNA[casilla] == COLUMNA[DB]))
			posevaln += 8;
		// La columna esta abierta ?
        if(Fila_Ultimo_PeonB[COLUMNA[casilla]] == no_wpawn_in_col)
        posevaln += 16;
		else posevaln += 8;
	 }
	 break;

case D_N:    
	 DamasN++; 
	 if(pb_controla(casilla)) posevaln -= 24;
	 if(FILA[casilla]== fila_2){
		if(FILA[Pos_RB]== fila_1) posevaln += 20;
		else posevaln += 10;
	 }//fila 7  
	 posevaln += bq_pcsq_eg[casilla];
     posevaln += Evalua_DamaN(casilla);
	 posevaln += TROPISMO_DAMA[Distancia[casilla][Pos_RB]];
	
	 break;	

	 }//switch
  }// for

//** REAJUSTE DE LA EVALUACION, ahora que tenemos mas informacion
//** procedemos a afinar un poco mas la evaluacion

// En los finales valoramos los peones un poco mas
posevalb += (PeonesBB * 14);	
posevaln += (PeonesNN * 14);	

posevalb += (DamasB * 32);	
posevaln += (DamasN * 32);	

// Alfil malo
if (AlfilesB == 1 && PeonesBB > 2) {
	int x,peones = 0;
	for(x = 0; x < 16; x++){
		if(contenido[BOARD_16[x]] == P_B && 
		COLOR_CA[BOARD_16[x]] == ColorAlfilB) peones++;
	}
    if(peones > 1) posevalb -= peones * 6; //mg= 4, eg = 6 
}

if (AlfilesN == 1 && PeonesNN > 2) {
	int x,peones = 0;
	for(x = 0; x < 16; x++){
		if(contenido[BOARD_16[x]] == P_N && 
		COLOR_CA[BOARD_16[x]] == ColorAlfilN) peones++;
	}
	if(peones > 1) posevaln -= peones * 6; //mg= 4, eg = 6 
}

/*
// Rey sin salida en peligro de mate, no probado
if( DamasN +TorresN > 0 ){
	if(contenido[A1] == R_B && contenido[A2] == P_B && contenido[B2] == P_B)
		posevalb -= 10;
	else if(contenido[H1] == R_B && contenido[H2] == P_B && contenido[G2] == P_B)
		posevalb -= 10;
}
if( DamasB +TorresB > 0 ){
	if(contenido[A8] == R_N && contenido[A7] == P_N && contenido[B7] == P_N)
		posevaln -= 10;
	else if(contenido[H8] == R_N && contenido[H7] == P_N && contenido[G7] == P_N)
		posevaln -= 10;
}
*/
// Intercambio de fichas usado tradicionalmente en Crafty
	
	Dif_Valor_Fichas = (Valor_FichasB - Valor_FichasN);
		               
	Dif_Fichas_Menores = (CaballosB + AlfilesB) - 
		                 (CaballosN + AlfilesN);
    //menor por peones
    if (Dif_Valor_Fichas >=  VAL_C) posevalb += 50;			        
	else if (Dif_Valor_Fichas <= -VAL_C) posevaln += 50;
    //menor por torre
	else if (Dif_Valor_Fichas >= (VAL_T- VAL_A)) posevalb += 20;		
	else if (Dif_Valor_Fichas <= -(VAL_T-VAL_A)) posevaln += 20;
	//dos menores por torre, o tres por dama
	else if (Dif_Fichas_Menores >= 2)  posevalb += 30;		       
	else if (Dif_Fichas_Menores <= -2) posevaln += 30;

	//if (DamasB && !DamasN) posevalb += 30;
   // else if (!DamasB && DamasN)posevaln += 30;

	// Miramos si tenemos algun peon pasado que corona solo
		if(dist_para_coronarB < dist_para_coronarN)
			posevalb += (600 -(60 * dist_para_coronarB));
		else if(dist_para_coronarN < dist_para_coronarB)
			posevaln += (600 -(60 *dist_para_coronarN));
	
//** Si es un final de alfiles de diferente color 
//** reducimos la evaluacion

  if(Valor_FichasB == VAL_A && 
	 Valor_FichasN == VAL_A &&
	 ColorAlfilB != ColorAlfilN)
     eval /= 2;


  // Ajustamos el valor de las torres y los caballos dependiendo
  // del num. de peones propios; idea de GM L.Kaufman
    posevalb += TorresB   * AJUSTE_T[PeonesBB];
	posevalb += CaballosB * AJUSTE_C[PeonesBB];
	posevaln += TorresN   * AJUSTE_T[PeonesNN];
	posevaln += CaballosN * AJUSTE_C[PeonesNN];

  // Penalizamos quedarnos sin peones
	if(solo_peones){
		if(PeonesBB > PeonesNN) posevalb += 90;
		else if(PeonesNN > PeonesBB) posevaln += 90;
	}
	else {
		if(PeonesBB == 1) posevalb -= 50;
		else if(PeonesBB == 0) posevalb -= 100;
		if(PeonesNN == 1) posevaln -= 50;
		else if(PeonesNN == 0) posevaln -= 100;
	}


   // Bonus por pareja de alfiles  
   if(AlfilesB >= 2) posevalb += 60;
   if(AlfilesN >= 2) posevaln += 60;
	  
//** Si uno de los bandos tiene una ventaja de 2 peones o mas
//** se favorece el cambio de fichas, no el de peones
   if(MaterialBB - MaterialNN >= 200)
	   posevalb -= (FichasBB + FichasNN) * 8; 
   else if(MaterialNN - MaterialBB >= 200)
	   posevaln -= (FichasBB + FichasNN) * 8; 

if(Color == BLANCAS)
	 eval += (posevalb - posevaln)+tempo_eg;
else eval += (posevaln - posevalb)+tempo_eg;

//** Miramos si es complicado ganar,
//** reducimos la evaluacion
if(solo_piezas) {	
	//(T,TA,TC,AA,AC,CC) vs (T,TA,TC,AA,AC,CC)
	if((MaterialBB <= VAL_T+VAL_A && 
		MaterialBB >= VAL_T)      &&
       (MaterialNN <= VAL_T+VAL_A && 
		MaterialNN >= VAL_T)) {
		 eval /= 4;
	}
	//(TT,TA,TC) vs ((TT,TA,TC)
	else if((MaterialBB <= VAL_T*2 && 
		MaterialBB >= VAL_T+VAL_C)      &&
       (MaterialNN <= VAL_T*2 && 
		MaterialNN >= VAL_T+VAL_C)) {
		 eval /= 4;
	}
	//(C,CC,A,AA,AC,T) vs (C,CC,A,AA,AC,T)
	else if ((MaterialBB <= 2*VAL_A && MaterialBB >= VAL_C) &&
             (MaterialNN <= 2*VAL_A && MaterialNN >= VAL_C ))
		 eval /= 4;
}

 //Un peon
 if(PeonesBB + PeonesNN == 1){
	if(PeonesBB == 1){
		if(!FichasBB && FichasNN && MaterialNN <= VAL_A) eval /= 4;
		else if((Valor_FichasB > 0 && Valor_FichasB <= VAL_A) && 
				(Valor_FichasN > 0 && Valor_FichasN <= VAL_T))eval /= 4;
	}
	else if(PeonesNN == 1){
		if(!FichasNN && FichasBB && MaterialBB <= VAL_A) eval /= 4;
		else if((Valor_FichasN > 0 && Valor_FichasN <= VAL_A) && 
				(Valor_FichasB > 0 && Valor_FichasB <= VAL_T))eval /= 4;
	}
 }

// Conforme nos acercamos a la regla de los 50 movimientos,
// la evaluacion se reduce ( o aumenta si es negativa), un
// 5% con cada movimiento.
if (fifty > 80 && fifty < 100) {   
int quedan = 101 - fifty;    
eval = eval * quedan / 20;
  
}

//Almacenamos la evaluacion en las hash
store_eval(eval,Color);
return eval;
}// fase final



//***** EVALUACION APERTURA Y MEDIO JUEGO ***************

else {

	// Lazy eval
if(Valor_FichasB >= VAL_FICHAS_SUFICIENTE &&
   Valor_FichasN >= VAL_FICHAS_SUFICIENTE){

	if((eval < alpha - 350)||
	   (eval > beta + 350)){
	   PosC++;
	   return eval;
	}	
}

else if((eval < alpha - VAL_T)||
	    (eval > beta + VAL_T)){
	   PosC++;
	   return eval;
	}	


//*Probamos a ver si ya tenemos evaluada la posicion
hscore = probe_eval(Color);
if (hscore != -VALMATE){
	PosH++;
	return hscore;	
}

init_peones();

   	PosL++;

   DamasB=TorresB=AlfilesB=CaballosB=PeonesB = 0;
   DamasN=TorresN=AlfilesN=CaballosN=PeonesN = 0;

   W_can_atak = (DB && FichasBB >= 2);
   B_can_atak = (DN && FichasNN >= 2);

// Si estamos en la apertura evaluamos el desarrollo 
  if(Valor_FichasB >= VAL_FICHAS_SUFICIENTE || 
	 Valor_FichasN >= VAL_FICHAS_SUFICIENTE){
		posevalb += Desarrollo_B();
		posevaln += Desarrollo_N();
  }
  else {
	 desarrolloB = 6;
	 desarrolloN = 6;
  }

  // Evaluamos si el Rey se encuentra protegido por sus peones
   if(PeonesBB > 3 || PeonesNN > 3){
   posevalb += evalua_seguridad_RB();
   posevaln += evalua_seguridad_RN();
   }

// Evaluacion fichas blancas, apertura y medio juego
for (i = 0; i < Num_FiB; i++){

     casilla = Lista_FichasB[i]; 
	 switch(contenido[casilla]) {

case R_B:       
		posevalb += wk_pcsq_mg[casilla];
		//perdemos la opcion de enroque ??
		if(enrocado_B == false){
			if((Movida[E1])||((Movida[H1])&&(Movida[A1])))
				posevalb -= 20;
			}		
	    break;

case P_B:
	    posevalb += EvaluaPeonB(casilla);
	    break;

case C_B:
		CaballosB++;
		if(pn_controla(casilla)) posevalb -= 8;
		if(outpost[casilla] &&
			Fila_Ultimo_PeonN[COLUMNA[casilla]-1] < FILA[casilla] &&
			Fila_Ultimo_PeonN[COLUMNA[casilla]+1] < FILA[casilla] ) {
			if(contenido[casilla-9] == P_B) posevalb += outpost[casilla];
			if(contenido[casilla-11] == P_B) posevalb += outpost[casilla];
		}

		posevalb += wn_pcsq_mg[casilla];
		if(W_can_atak) posevalb += Evalua_CaballoB_Atak(casilla);
		else           posevalb += Evalua_CaballoB(casilla);
		posevalb += TROPISMO_FICHA[Distancia[casilla][Pos_RN]];
		break;

case A_B:
	AlfilesB++;
	ColorAlfilB = COLOR_CA[casilla];
	if(pn_controla(casilla)) posevalb -= 8;
	// Alfil atrapado
	if(casilla == A6 && contenido[B5] ==  P_N) {posevalb  -= 50; break;}
    if(casilla == A7 && contenido[B6] ==  P_N) {posevalb  -= 150;break;}
    if(casilla == B8 && contenido[C7] ==  P_N) {posevalb  -= 150;break;}
	if(casilla == H6 && contenido[G5] ==  P_N) {posevalb  -= 50; break;}
    if(casilla == H7 && contenido[G6] ==  P_N) {posevalb  -= 150;break;}
    if(casilla == G8 && contenido[F7] ==  P_N) {posevalb  -= 150;break;}
	
	posevalb += wb_pcsq_mg[casilla];
	if(W_can_atak) posevalb += Evalua_AlfilB_Atak(casilla);
	else           posevalb += Evalua_AlfilB(casilla);
	posevalb += TROPISMO_FICHA[Distancia[casilla][Pos_RN]];
	break;

case T_B:
		TorresB++;
		if(pn_controla(casilla)) posevalb -= 12;
		// Si la Torre se encuentra atrapada por culpa de
		// su Rey, penalizamos y no seguimos evaluando
		if(enrocado_B == false){ 
			if((contenido[F1] == R_B || contenido[G1] == R_B) && 
    		(casilla == H1 || casilla == H2 || 
			casilla == G1)){
			posevalb -= 80;
			break;
			}

			else if((contenido[C1] == R_B || contenido[B1] == R_B) && 
			(casilla == A1 || casilla == A2 || 
			casilla == B1)){
			posevalb -= 80;
			break;
			}
	    }//enrocado_B == false

		posevalb +=	wr_pcsq_mg[casilla];
		// Mientras no se complete el desarrollo, no evaluamos
		if(desarrolloB > 2) {
			// Torre en septima
			if(FILA[casilla]== fila_7){
				if(FILA[Pos_RN]== fila_8) posevalb += 16;
				else {
					for(x= A7; x < H7; x += 1)
						if(contenido[x] == P_N){ 
							posevalb += 16;
							break;
						}
				}
			}// fila 7
			// Esta en columna semiabieta ?
			if(Fila_Ultimo_PeonB[COLUMNA[casilla]] == no_wpawn_in_col){
				// en columna de la Dama o Rey contrario
				if(abs(COLUMNA[casilla] - COLUMNA[Pos_RN]) <= 1 ||
					 (COLUMNA[casilla] == COLUMNA[DN]))
					posevalb += 8;
				// La columna esta abierta ?
				if(Fila_Ultimo_PeonN[COLUMNA[casilla]] == no_bpawn_in_col)
					posevalb += 16;
				else posevalb += 8;
			}// semi
			if(W_can_atak) posevalb += Evalua_TorreB_Atak(casilla);
			else           posevalb +=  Evalua_TorreB(casilla);
			posevalb += TROPISMO_FICHA[Distancia[casilla][Pos_RN]];
			//if(TB1) TB2 = casilla;
	        //else    TB1 = casilla;	
		}//desarrolloB > 4
 
	    break;	

case D_B:
     DamasB++;  
	 if(pn_controla(casilla)) posevalb -= 24;

		//** Mover la Dama sin estar desarrollado es malo
		if(desarrolloB < 3 && FILA[casilla] > 2 ) posevalb -= 20;
		if(FILA[casilla]== fila_7){
			if(FILA[Pos_RN]== fila_8) posevalb += 16;
			else posevalb += 8;
		}// fila = 7
		posevalb +=	wq_pcsq_mg[casilla];
		if(W_can_atak) posevalb += Evalua_DamaB_Atak(casilla);
		else           posevalb += Evalua_DamaB(casilla);
		posevalb += TROPISMO_DAMA[Distancia[casilla][Pos_RN]];
		
	    break;

	 }// switz       
    }//for

// Evaluacion fichas negras, apertura y medio juego 
for (i = 0; i < Num_FiN; i++){

     casilla = Lista_FichasN[i]; 
	 switch(contenido[casilla]) {

case R_N: 
		posevaln += bk_pcsq_mg[casilla];
		if(enrocado_N == false){
			if((Movida[E8]>0)||((Movida[H8]>0)&&(Movida[A8]>0)))
				posevaln -= 20;
		}
	    break;	 
case P_N:
        posevaln += EvaluaPeonN(casilla);
	    break;

case C_N:   
		CaballosN++;
		if(pb_controla(casilla))	posevaln -= 8;
		if(outpost[FLIP[casilla]] &&
		   Fila_Ultimo_PeonB[COLUMNA[casilla]-1] > FILA[casilla] &&
	       Fila_Ultimo_PeonB[COLUMNA[casilla]+1] > FILA[casilla] ){
			if(contenido[casilla+9] == P_N) posevaln += outpost[FLIP[casilla]];
			if(contenido[casilla+11] == P_N) posevaln += outpost[FLIP[casilla]];
		}
	
         posevaln += bn_pcsq_mg[casilla];
		 if(B_can_atak) posevaln += Evalua_CaballoN_Atak(casilla);
		 else           posevaln += Evalua_CaballoN(casilla);
		 posevaln += TROPISMO_FICHA[Distancia[casilla][Pos_RB]];
     
	     break;

case A_N:
        AlfilesN++;
		ColorAlfilN = COLOR_CA[casilla];
		if(pb_controla(casilla))	posevaln -= 8;
		// Alfil atrapado
		if (casilla == A3 && contenido[B4] == P_B ) {posevaln -= 50; break;}
		if (casilla == A2 && contenido[B3] == P_B ) {posevaln -= 150;break;}
		if (casilla == B1 && contenido[C2] == P_B ) {posevaln -= 150;break;}
		if (casilla == H3 && contenido[G4] == P_B ) {posevaln -= 50; break;}
		if (casilla == H2 && contenido[G3] == P_B ) {posevaln -= 150;break;}
		if (casilla == G1 && contenido[F2] == P_B ) {posevaln -= 150;break;}
		
		posevaln += bb_pcsq_mg[casilla];
		if(B_can_atak) posevaln += Evalua_AlfilN_Atak(casilla);
	    else           posevaln += Evalua_AlfilN(casilla);
		posevaln += TROPISMO_FICHA[Distancia[casilla][Pos_RB]];
	    break;

case T_N:
		TorresN++;
		if(pb_controla(casilla))	posevaln -= 12;
		//Torre atrapada
		if(enrocado_N == false) {
			if((contenido[F8] == R_N || contenido[G8] == R_N) && 
			(casilla == H8 || casilla == H7 || 
			casilla == G8)){
			posevaln -= 80;
			break;
			}
		 
			else if((contenido[C8] == R_N || contenido[B8] == R_N) && 
			(casilla == A8 || casilla == A7 || 
			casilla == B8)){
			posevaln -= 80;
			break;
			}
		}

		posevaln +=	br_pcsq_mg[casilla];
		if(desarrolloN > 2){
		// Torre en septima
		if(FILA[casilla]== 2){
			if(FILA[Pos_RB]== 1) posevaln += 16;
			else {
			 for(x= A2; x < H2; x += 1)
				 if(contenido[x] == P_B){ 
					 posevaln += 16;
					 break;
				 }
			}
		 }
		// Esta en columna semiabieta ?
		if(Fila_Ultimo_PeonN[COLUMNA[casilla]] == no_bpawn_in_col){
			// en columna de la Dama o Rey contrario
			if(abs(COLUMNA[casilla] - COLUMNA[Pos_RB]) <= 1 ||
				  (COLUMNA[casilla] == COLUMNA[DB]))
				posevaln += 8;
			// La columna esta abierta ?
			if(Fila_Ultimo_PeonB[COLUMNA[casilla]] == no_wpawn_in_col)
				posevaln += 16;
				else posevaln += 8;
		 }
			if(B_can_atak) posevaln += Evalua_TorreN_Atak(casilla);
			else           posevaln += Evalua_TorreN(casilla);
			posevaln += TROPISMO_FICHA[Distancia[casilla][Pos_RB]];
           // if(TN1) TN2 = casilla;
	       // else    TN1 = casilla;	
		}//desarrolloN > 4

	    break;

case D_N:    
		DamasN++; 
		if(pb_controla(casilla))	posevaln -= 24;
	    if(desarrolloN < 3 && FILA[casilla] < fila_7) posevaln -= 20; 
		if(FILA[casilla]== fila_2){
			if(FILA[Pos_RB]== fila_1) posevaln += 16;
			else posevaln += 8;
		}//fila 7  
		posevaln +=	bq_pcsq_mg[casilla];
		if(B_can_atak) posevaln += Evalua_DamaN_Atak(casilla);
		else posevaln += Evalua_DamaN(casilla);			
		posevaln += TROPISMO_DAMA[Distancia[casilla][Pos_RB]];
	    break;

	 }// switz       
  }//for


//** REAJUSTE DE LA EVALUACION, ahora que tenemos mas informacion
//** procedemos a afinar un poco mas la evaluacion


// Intercambio de fichas usado tradicionalmente en Crafty
	Dif_Valor_Fichas = (Valor_FichasB - Valor_FichasN);		               
	Dif_Fichas_Menores = (CaballosB + AlfilesB) - 
		                 (CaballosN + AlfilesN);
	//mayor por peones
	if (Dif_Valor_Fichas >=  VAL_T) posevalb += 160;	
	else if (Dif_Valor_Fichas <=  -VAL_T) posevaln += 160;
    //menor por peones
    else if (Dif_Valor_Fichas >=  VAL_C) posevalb += 80;			        
	else if (Dif_Valor_Fichas <= -VAL_C) posevaln += 80;
    //menor por torre
	else if (Dif_Valor_Fichas >= (VAL_T- VAL_A)) posevalb += 50;		
	else if (Dif_Valor_Fichas <= -(VAL_T-VAL_A)) posevaln += 50;	
    //dos menores por torre, o tres por dama
	else if (Dif_Fichas_Menores >= 2)  posevalb += 50;		       
	else if (Dif_Fichas_Menores <= -2) posevaln += 50;

	if(DamasB == 0 && DamasN == 0){
		posevalb += (PeonesBB * 10);	
		posevaln += (PeonesNN * 10);
	}
  // Bonus Pareja de alfiles
	 if(AlfilesB >= 2) posevalb += 40;
	 if(AlfilesN >= 2) posevaln += 40;
	
  // Ajustamos el valor de las torres y los caballos dependiendo
  // del num. de peones propios; idea de GM L.Kaufman
    posevalb += TorresB   * AJUSTE_T[PeonesBB];
	posevalb += CaballosB * AJUSTE_C[PeonesBB];
	posevaln += TorresN   * AJUSTE_T[PeonesNN];
	posevaln += CaballosN * AJUSTE_C[PeonesNN];

// Tambien segun el GM L.Kaufman, conservar la pareja de
  // caballos o de torres es redundante
	if(CaballosB >= 2) posevalb -= 10;
	if(CaballosN >= 2) posevaln -= 10;
	if(TorresB >= 2)   posevalb -= 16;
	if(TorresN >= 2)   posevaln -= 16;

// Alfil malo ?? from Crafty
if (AlfilesB == 1 && PeonesBB > 2) {
	int x,peones = 0;
	for(x = 0; x < 16; x++){
		if(contenido[BOARD_16[x]] == P_B && 
		COLOR_CA[BOARD_16[x]] == ColorAlfilB) peones++;
	}
	
    if(peones > 1) posevalb -= peones * 4; //mg= 4, eg = 6 
}

if (AlfilesN == 1 && PeonesNN > 2) {
	int x,peones = 0;
	for(x = 0; x < 16; x++){
		if(contenido[BOARD_16[x]] == P_N && 
		COLOR_CA[BOARD_16[x]] == ColorAlfilN) peones++;
	}
	
    if(peones > 1) posevaln -= peones * 4; //mg= 4, eg = 6 
}	


if(atacantesB >=2){
	int x;
	for(x = 0; x < 5; x++){
		if(es_casilla(Pos_RN + Inc_Atac_Al_RN[x])){
			if(pb_controla(Pos_RN + Inc_Atac_Al_RN[x])) ataquesB++;
		}
	}
	posevalb += Bonus_Counter_Atac[ataquesB];
}

if(atacantesN >=2){
	int x;
	for(x = 0; x < 5; x++){
		if(es_casilla(Pos_RB + Inc_Atac_Al_RB[x])){
			if(pn_controla(Pos_RB + Inc_Atac_Al_RB[x])) ataquesN++;
		}
	}
	posevaln += Bonus_Counter_Atac[ataquesN];
}

//** Si uno de los bandos tiene una ventaja de 2 peones o mas
//** se favorece el cambio de fichas, no el de peones
   if(MaterialBB - MaterialNN >= 200)
	   posevalb -= (FichasBB + FichasNN) * 8; 
   else if(MaterialNN - MaterialBB >= 200)
	   posevaln -= (FichasBB + FichasNN) * 8; 
 
if(Color == BLANCAS)
	 eval = (eval + (posevalb - posevaln) +tempo_mg);
else eval = (eval + (posevaln - posevalb) +tempo_mg);

// Conforme nos acercamos a la regla de los 50 movimientos,
// la evaluacion se reduce ( o aumenta si es negativa), un
// 5% con cada movimiento.
if (fifty > 80 && fifty < 100) {   
int quedan = 101 - fifty;    
eval = eval * quedan / 20;
}

//Almacenamos la evaluacion en las hash
store_eval(eval, Color);
return eval;
}// apertura y medio juego

} //evalua_posicion




