
//** MODULO PARA EVALUAR FINALES - PRONTO UNA REVISION *****

// Tabla utilizada en el mate al Rey solitario   
static const int TabMateRey[100] = {
/**   A   B   C   D   E   F   G   H  */
  0,  0,  0,  0,  0,  0,  0,  0,  0, 0,
  0,  0,  0,  0,  0,  0,  0,  0,  0, 0,
  0,  0,  4,  8, 16, 16,  8,  4,  0, 0,    //* A1 ... H1 
  0,  4, 32, 40, 48, 48, 40, 32,  4, 0,
  0,  8, 40, 56, 64, 64, 56, 40,  8, 0,
  0, 16, 48, 64, 99, 99, 64, 48, 16, 0,
  0, 16, 48, 64, 99, 99, 64, 48, 16, 0,
  0,  8, 40, 56, 64, 64, 56, 40,  8, 0,
  0,  8, 32, 40, 48, 48, 40, 32,  4, 0,
  0,  0,  4,  8, 16, 16,  8,  4,  0, 0 };  //* A8 ... H8  


// Tabla para dar el mate de Alfil y caballo  
static const int Mate_AlfilB_Caballo[100] = {
/**   A   B   C   D   E   F   G   H  */
  0,   0,   0,   0,   0,  0,    0,   0,   0, 0,
  0,   0,   0,   0,   0,  0,    0,   0,   0, 0,
  0,   0,  10,  20,  30, 60,  100, 150, 200, 0,    //* A1 ... H1 
  0,  10,  20,  30,  60, 100, 150, 200, 150, 0,
  0,  20,  30,  60, 100, 150, 200, 150, 100, 0,
  0,  30,  60, 100, 150, 200, 150, 100,  60, 0,
  0,  60, 100, 150, 200, 150, 100,  60,  30, 0,
  0, 100, 150, 200, 150, 100,  60,  30,  20, 0,
  0, 150, 200, 150, 100,  60,  30,  20,  10, 0,
  0, 200, 150, 100,  60,  30,  20,  10,   0, 0 };  //* A8 ... H8  


// Tabla para dar el mate de Alfil y caballo  
static const int Mate_AlfilN_Caballo[100] = {
/**   A   B   C   D   E   F   G   H  */
  0,  0,  0,  0,  0,  0,  0,  0,  0, 0,
  0,  0,  0,  0,  0,  0,  0,  0,  0, 0,
  0,200,150,100, 60, 30, 20, 10,  0, 0,    //* A1 ... H1
  0,150,200,150,100, 60, 30, 20, 10, 0,
  0,100,150,200,150,100, 60, 30, 20, 0,
  0, 40,100,150,200,150,100, 60, 30, 0,
  0, 60, 40,100,150,200,150,100, 60, 0,
  0, 20, 60, 60,100,150,200,150,100, 0,
  0, 10, 20, 30, 60,100,150,200,150, 0,
  0,  0, 10, 20, 30, 60,100,150,200, 0 };  //* A8 ... H8  
 
int Good_push[8]= { 0, 0, 100, 80, 60, 40, 20, 10 };

int AlfilPeon_Alfil(int turno){
int vistas,Color_AG,Color_AP,peon,col;
int Pos_AG,Pos_AP, ganador,eval,ca;
vistas = eval = 0;

if(MaterialBB > MaterialNN)
	 ganador = BLANCAS;
else ganador = NEGRAS;
   
if(ganador == BLANCAS){
	for(ca = A1; vistas < 3; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_B){
			Color_AG = COLOR_CA[ca];
			Pos_AG = ca;
			vistas++;}
        else if(contenido[ca] == A_N){
			Color_AP = COLOR_CA[ca];
			Pos_AP = ca;
			vistas++;}
        else if(contenido[ca] == P_B){
			peon = ca;
			col = COLUMNA[ca];
			vistas++;}
	}//for

	//** Si el Rey contrario esta delante del peon en casilla de diferente
	//** color al alfil contrario, y alfiles diferente color, tablas.
	if(COLUMNA[Pos_RN]== col && Pos_RN > peon &&
	   Color_AG != COLOR_CA[Pos_RN]) 
	   eval = 0;
	//** Si alfiles diferente color, si alfil contrario controla alguna casilla
	//** por donde tiene que pasar el peon, tablas
	else if(Color_AG != Color_AP){		
		for(ca = peon+10; ca < CORONA_B[peon]; ca += 10 ){
			if(AlfilN_ataca(ca)){ 
			  eval = FILA[peon];
			  break;}
		}
	}
	//** Vale seguramente los alfiles son del mismo color
	else { eval = 100+(20 * FILA[peon])+
		        (5*Distancia[Pos_RN][CORONA_B[peon]])-
                (5*Distancia[Pos_RB][CORONA_B[peon]]);
		if(AlfilN_ataca(ca+10) || AlfilN_ataca(ca+20))
			eval -= 100;
	}
}// Ganador = blancas

else if(ganador = NEGRAS){ // ganador = negras
	for(ca = A1; vistas < 3; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_N){
			Color_AG = COLOR_CA[ca];
			Pos_AG = ca;
			vistas++;}
        else if(contenido[ca] == A_B){
			Color_AP = COLOR_CA[ca];
			Pos_AP = ca;
			vistas++;}
        else if(contenido[ca] == P_N){
			peon = ca;
			col = COLUMNA[ca];
			vistas++;}
	}//for
	if(COLUMNA[Pos_RB]== col && Pos_RB < peon &&
		Color_AG != COLOR_CA[Pos_RB]) 
		eval = 0;
	
	else if(Color_AG != Color_AP){
		for(ca = peon-10; ca > CORONA_N[peon]; ca -= 10){
			if(AlfilB_ataca(ca)){ 
			  eval = 9-FILA[peon];
			  break;}
		}
	}
	else { eval = 100+(20 *(9-FILA[peon]))+
		        (5*Distancia[Pos_RB][CORONA_N[peon]])-
                (5*Distancia[Pos_RN][CORONA_N[peon]]);

		if(AlfilB_ataca(ca-10) || AlfilB_ataca(ca-20))
			eval -= 100;
	}	
}//Ganador = negras

if((ganador == BLANCAS && turno == BLANCAS)||
   (ganador == NEGRAS && turno == NEGRAS)){
         store_eval(eval, Color);
	     return eval;
}
else {
         store_eval(-eval, Color);
	     return -eval;}
}

// Final Torre y peon contra Torre
int RTP_RT(){
int pos_peon,ca;
int score = 1;
int torre_G, torre_P;

if(MaterialBB > MaterialNN){
	for( ca = A1; ca < H8; ca++){
	if(contenido[ca] == VACIO || contenido[ca] == FUERA) continue;
		if(contenido[ca] == P_B) pos_peon = ca;
		else if(contenido[ca] == T_B) torre_G = ca;
		else if(contenido[ca] == T_N) torre_P = ca;
	}// for

	// Esto no es verdad, pero ayuda mucho para hacerlo bien
	if(Distancia[Pos_RN][CORONA_B[pos_peon]] <= 1
	  && Distancia[Pos_RB][CORONA_B[pos_peon]] >= 2)
	  score = 0;

	else if(Distancia[COLUMNA[Pos_RN]][COLUMNA[pos_peon]] <= 1
		 && Pos_RN > pos_peon // Rey debil delante del peon
		 && Distancia[Pos_RN][CORONA_B[pos_peon]]+1 < Distancia[Pos_RB][CORONA_B[pos_peon]])
		 score = 0;
/*
	else if (pos_peon == A7 || pos_peon == B7 || pos_peon == C7 || pos_peon == D7
      && torre_G == pos_peon+10 // torre delante del peon
      && (Pos_RN == G7 || Pos_RN == H7)
      && COLUMNA[torre_P] == COLUMNA[pos_peon]
	  && Distancia[Pos_RB][pos_peon] > 1)
       score = 0;

	else if (pos_peon == H7 || pos_peon == G7 || pos_peon == F7 || pos_peon == E7
      && torre_G == pos_peon+10 // torre delante del peon
      && (Pos_RN == A7 || Pos_RN == B7)
      && COLUMNA[torre_P] == COLUMNA[pos_peon]
	  && Distancia[Pos_RB][pos_peon] > 1)
       score = 0;
*/
	 else score = 128 + (Good_push[Distancia[pos_peon][CORONA_B[pos_peon]]]) 
		              + (16*Distancia[Pos_RN][CORONA_B[pos_peon]]);
	
}// blancas

else if(MaterialNN > MaterialBB){
	for( ca = A1; ca < H8; ca++){
	if(contenido[ca] == VACIO || contenido[ca] == FUERA) continue;
		if(contenido[ca] == P_N) pos_peon = ca;
		else if(contenido[ca] == T_N) torre_G = ca;
		else if(contenido[ca] == T_B) torre_P = ca;
	}// for

	// Esto no es verdad, pero ayuda mucho para hacerlo bien
	if(Distancia[Pos_RB][CORONA_N[pos_peon]] <= 1
	  && Distancia[Pos_RN][CORONA_N[pos_peon]] >= 2)
	  score = 0;

	else if(Distancia[COLUMNA[Pos_RB]][COLUMNA[pos_peon]] <= 1
		 && Pos_RB < pos_peon // Rey debil delante del peon
		 && Distancia[Pos_RB][CORONA_N[pos_peon]] < Distancia[Pos_RN][CORONA_N[pos_peon]])
		 score = 0;
/*
	else if (pos_peon == A2 || pos_peon == B2 || pos_peon == C2 || pos_peon == D2
      && torre_G == pos_peon-10 // torre delante del peon
      && (Pos_RB == G2 || Pos_RB == H2)
      && COLUMNA[torre_P] == COLUMNA[pos_peon]
	  && Distancia[Pos_RN][pos_peon] > 1)
       score = 0;

	else if (pos_peon == H2 || pos_peon == G2 || pos_peon == F2 || pos_peon == E2
      && torre_G == pos_peon-10 // torre delante del peon
      && (Pos_RB == A2 || Pos_RN == B2)
      && COLUMNA[torre_P] == COLUMNA[pos_peon]
	  && Distancia[Pos_RN][pos_peon] > 1)
       score = 0;
*/
	else score = 128 + (Good_push[Distancia[pos_peon][CORONA_N[pos_peon]]]) 
		             + (16*Distancia[Pos_RB][CORONA_N[pos_peon]]);
	
}// negras
if( (MaterialBB > MaterialNN && Color == BLANCAS)||
	(MaterialNN > MaterialBB && Color == NEGRAS))
	 {store_eval( score, Color); return  score;}
else {store_eval(-score, Color); return -score;}

}//RTP_RT


//** Comprobamos si se trata de tablas teoricas,
//** peon en columna de torre y alfil por casillas 
//** de diferente color a la casilla de coronacion
int Alfil_peon(int turno)
{
int color_alfil,ca,peon,ganador;
int eval = 0;
int vistas = 0;

if(MaterialBB > MaterialNN) ganador = BLANCAS;		
else ganador = NEGRAS;
		
if(ganador == BLANCAS){

	for(ca = A1; vistas < 2; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_B){
			color_alfil = COLOR_CA[ca];
			vistas++;}
        else if(contenido[ca] == P_B){
			peon = ca;
			vistas++;}
	}//for

	if((COLUMNA[peon] == 1 || COLUMNA[peon] == 8) &&
       (COLOR_CA[CORONA_B[peon]]!= color_alfil)&&
	   (Distancia[Pos_RN][CORONA_B[peon]]<= 1))
	   eval = 0;
	   else eval = 400 + 20*FILA[peon];
}//Ganador = blancas

else { // ganador = negras

	for(ca = A1; vistas < 2; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_N){
			color_alfil = COLOR_CA[ca];
			vistas++;}
        else if(contenido[ca] == P_N){
			peon = ca;
			vistas++;}
	}//for

	if((COLUMNA[peon] == 1 || COLUMNA[peon] == 8) &&
       (COLOR_CA[CORONA_N[peon]]!= color_alfil)&&
	   (Distancia[Pos_RB][CORONA_N[peon]]<= 1))
	   eval = 0;
	   else eval = 400 + 20*(9-FILA[peon]);
}//Ganador = negras

if((ganador == BLANCAS && turno == BLANCAS)||
   (ganador == NEGRAS && turno == NEGRAS)){
         store_eval(eval, Color);
	     return eval;}
else {
        store_eval(-eval, Color);
	     return -eval;}

}

int Dama_peon(int turno) { //*******************
int ca,peon,ganador;
int eval = 0;
int vistas = 0;

if(MaterialBB > MaterialNN) ganador = BLANCAS;		
else ganador = NEGRAS;
		
if(ganador == BLANCAS){
	for(ca = A1; vistas < 1; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == P_N){
			peon = ca;
			vistas++;}
        
	}//for
	if((COLUMNA[peon] == 1 || COLUMNA[peon] == 8 ||
		COLUMNA[peon] == 3 || COLUMNA[peon] == 6) &&
       FILA[peon] == 2 &&
	   (Distancia[Pos_RN][peon]<= 2))
	   eval = 0;
	   else eval = 850 - (20*Distancia[Pos_RB][Pos_RN]);


}//Ganador = blancas

else { // ganador = negras
	for(ca = A1; vistas < 1; ca++){
	if(contenido[ca] == VACIO ||
       contenido[ca] == FUERA) continue;
		if(contenido[ca] == P_B){
			peon = ca;
			vistas++;}
	}//for
	if((COLUMNA[peon] == 1 || COLUMNA[peon] == 8 ||
		COLUMNA[peon] == 3 || COLUMNA[peon] == 6) &&
       FILA[peon] == 7 &&
	   (Distancia[Pos_RB][peon]<= 2))
	   eval = 0;
	   else eval = 850 - (20*Distancia[Pos_RB][Pos_RN]);
	
}//Ganador = negras

if((ganador == BLANCAS && turno == BLANCAS)||
   (ganador == NEGRAS && turno == NEGRAS)){
        store_eval(eval, Color);
	    return eval;}
else {
        store_eval(-eval, Color);
	    return -eval;}
}


//** Esta rutina tiene el proposito de ganar o no
//** perder posiciones dificiles, como Dama contra Torre

int Eval_ficha_ficha(int turno){	
int ganador,Rey_Ganador, Rey_Perdedor;
int ca,alfil,caballo,color_alfil;
int eval = 0;

// Dama contra Dama, o Torre contra torre
if(MaterialBB == MaterialNN){
	if(turno == BLANCAS){
	eval = TabMateRey[Pos_RB]- TabMateRey[Pos_RN];
	store_eval(eval, Color);
	return eval;}

	else{
	eval = TabMateRey[Pos_RN]- TabMateRey[Pos_RB];
	store_eval(eval, Color);
	return eval;}
}// material es igual

if(MaterialBB > MaterialNN) {
		ganador      = BLANCAS;
        Rey_Ganador  = Pos_RB;
		Rey_Perdedor = Pos_RN;}
else if(MaterialNN > MaterialBB){
		ganador      = NEGRAS;
        Rey_Ganador  = Pos_RN;
		Rey_Perdedor = Pos_RB;}

if(ganador == BLANCAS){

//** Dama contra Torre, el ganador quiere arrinconar al Rey
//** contrario, el perdedor todo lo contrario y ademas mantener
//** su torre cerca de su Rey, para no perderla en un jaque.
if(MaterialBB == VAL_D && MaterialNN == VAL_T){
eval =  600 + Good_push[Distancia [Rey_Ganador][Rey_Perdedor]] - TabMateRey[Rey_Perdedor];
}// Dama contra torre

// TORRE CONTRA ALFIL, el ganador quiere arrinconar al Rey
// contrario, el perdedor todo lo contrario y ademas tener
// el alfil alejado de su Rey, y el Rey en casillas del mismo
// color que las casillas del alfil, para evitar que se cubra
// de los jaques con el alfil.
else if(MaterialBB == VAL_T && MaterialNN == VAL_A){
for(ca = A1; ca < H9; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_N){
			alfil = ca;
			color_alfil = COLOR_CA[ca];
			break;}
	}
     eval = ( 100  - (TabMateRey[Rey_Perdedor] +
        (6 * Distancia[Rey_Ganador][Rey_Perdedor])+
		(4 * Distancia[Rey_Perdedor][alfil])+
		(COLOR_CA[Rey_Perdedor]== color_alfil ? 10:0)));
}//Torre vs Alfil

//TORRE CONTRA CABALLO, igual que Dama contra Torre
else if(MaterialBB == VAL_T && MaterialNN == VAL_C){
for(ca = A1; ca < H9; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == C_N){
			caballo = ca;
			break;}
}//for
     eval =  ( 150  - (TabMateRey[Rey_Perdedor] +
	    (10 * Distancia[Rey_Ganador][Rey_Perdedor])-
		(10 * Distancia [Rey_Perdedor][caballo])));
}//

//DAMA CONTRA ALFIL O CABALLO, igual que Dama contra Torre
else if(MaterialBB == VAL_D && (MaterialNN == VAL_A || MaterialNN == VAL_C)){
eval =  800 + Good_push[Distancia [Rey_Ganador][Rey_Perdedor]] - TabMateRey[Rey_Perdedor];    
}// Dama vs Alfil o Caballo
}//ganador = Blancas

else {//ganador == NEGRAS

//Dama contra Torre
if(MaterialNN == VAL_D && MaterialBB == VAL_T){
eval =  600 + Good_push[Distancia [Rey_Ganador][Rey_Perdedor]] - TabMateRey[Rey_Perdedor];	
}// Dama contra torre

//Torre contra Alfil
else if(MaterialNN == VAL_T && MaterialBB == VAL_A){
for(ca = A1; ca < H9; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_B){
			alfil = ca;
			color_alfil = COLOR_CA[ca];
			break;}
	}
     eval = ( 100  - (TabMateRey[Rey_Perdedor] +
        (6 * Distancia[Rey_Ganador][Rey_Perdedor])+
		(4 * Distancia[Rey_Perdedor][alfil])+
		(COLOR_CA[Rey_Perdedor]== color_alfil ? 10:0)));
}// Torre contra alfil

//Torre contra Caballo
else if(MaterialNN == VAL_T && MaterialBB == VAL_C){
for(ca = A1; ca < H9; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == C_B){
			caballo = ca;
			break;}
}//for
	eval =  ( 150  - (TabMateRey[Rey_Perdedor] +
	    (10 * Distancia[Rey_Ganador][Rey_Perdedor])-
		(10 * Distancia [Rey_Perdedor][caballo])));
}// Torre contra caballo

//Dama contra Alfil o Caballo
if(MaterialNN == VAL_D && (MaterialBB == VAL_A || MaterialBB == VAL_C)){
eval =  600 + Good_push[Distancia [Rey_Ganador][Rey_Perdedor]] - TabMateRey[Rey_Perdedor];
}// Dama contra alfil o caballo

}// ganador = negras

if((ganador == BLANCAS && turno == BLANCAS)||
   (ganador == NEGRAS && turno == NEGRAS)){
        store_eval(eval, Color);
	    return eval;}
else {
        store_eval(-eval, Color);
	    return -eval;}
}


int Eval_mate_alfil_caballo(){

int ganador;
int vistas = 0;
int ca,alfil;
int eval = 0; 
int valor_pos_rey_perdedor = 0;


if(MaterialBB > MaterialNN)      
	 ganador = BLANCAS;     
else ganador = NEGRAS;

if(ganador == BLANCAS){
for(ca= A1; vistas < 1; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_B){
			alfil = ca;
			vistas++;
			break;
		}
	}//for

if(COLOR_CA[alfil] == 1)  
 valor_pos_rey_perdedor = Mate_AlfilB_Caballo[Pos_RN];
else 
 valor_pos_rey_perdedor = Mate_AlfilN_Caballo[Pos_RN];	

eval  = VAL_D 
	  - 12 * Distancia[Pos_RB][Pos_RN]
	  - valor_pos_rey_perdedor; 
}// ganador = blancas
  
else {
for(ca= A1; vistas < 1; ca++){
		if(contenido[ca] == VACIO ||
           contenido[ca] == FUERA) continue;
		if(contenido[ca] == A_N){
			alfil = ca;
			vistas++;
			break;}
	}//for

if(COLOR_CA[alfil] == 1)  
 valor_pos_rey_perdedor = Mate_AlfilB_Caballo[Pos_RB];
else 
 valor_pos_rey_perdedor = Mate_AlfilN_Caballo[Pos_RB];

eval  = VAL_D 
	  - 12 * Distancia[Pos_RB][Pos_RN]
	  - valor_pos_rey_perdedor; 
}// ganador = negras

if((ganador == BLANCAS && Color == BLANCAS) ||
   (ganador == NEGRAS  && Color == NEGRAS)){ 
    store_eval(eval, Color);
    return eval;
}
else { 
	store_eval(-eval, Color);
	return -eval;
}

}//Eval_mate_alfil_caballo


int EvaluaRPR (int turno)
/**************************************************************************
 *  Basado en GNU 5
 *  Evaluador de Rey y Peon contra Rey, en la mayoria de los casos juega
 *  bien, pero alguna posicion ganadora puede terminar en tablas.
 **************************************************************************/
{
   int Peon, Rey_Ganador, Rey_Perdedor,casilla;
   int ganador, perdedor,score;
   Peon = score= 0;

if (MaterialBB > MaterialNN){
	 ganador = BLANCAS;
	 perdedor = NEGRAS;
     Rey_Ganador = Pos_RB;
     Rey_Perdedor = Pos_RN;
	 for (casilla = A1; casilla < H9; casilla++){
		 if(contenido[casilla] == VACIO || 
			contenido[casilla] == FUERA) continue;
		 if(contenido[casilla] == P_B){
			 Peon = casilla;
			 break;}
	 }					 
		
    score = 400 + (20 * FILA[Peon]);
    }

   else {
	 ganador = NEGRAS;
	 perdedor = BLANCAS;
     Rey_Ganador = Pos_RN;
     Rey_Perdedor = Pos_RB;
	 for (casilla = A1; casilla < H9; casilla++){
		 if(contenido[casilla] == P_N){
			Peon = casilla;
			break;}
	 }		 
    score = 400 + (20 * (9-FILA[Peon]));
    }

//** El peon puede coronar solo 
 
  if (ganador == BLANCAS)
   {
      if (turno == BLANCAS &&
		  Distancia[Peon][CORONA_B[Peon]]< 
		  Distancia[Pos_RN][CORONA_B[Peon]])
         return score;
	  else if (turno == NEGRAS &&
		  Distancia[Peon][CORONA_B[Peon]]< 
		  (Distancia[Pos_RN][CORONA_B[Peon]]-1))
         return -score;
      
   }
else if (ganador == NEGRAS)
   {
      if (turno == NEGRAS &&
		  Distancia[Peon][CORONA_N[Peon]]< 
		  Distancia[Pos_RB][CORONA_N[Peon]])
         return score;
	  else if (turno == BLANCAS &&
		  Distancia[Peon][CORONA_N[Peon]]< 
		  (Distancia[Pos_RB][CORONA_N[Peon]]-1))
         return -score;
      
   }

 //**  Si el peon esta en columna de torre, le damos
 //**  un tratamiento especial
 
  if (COLUMNA[Peon] == 1 || COLUMNA[Peon] == 8 ){

	if (ganador == BLANCAS){
	  if (turno == BLANCAS &&
		  Distancia[Rey_Perdedor][CORONA_B[Peon]]< 
		  Distancia[Rey_Ganador][CORONA_B[Peon]])
         return 0;
	  else if (turno == NEGRAS &&
		  Distancia[Rey_Perdedor][CORONA_B[Peon]]< 
		  Distancia[Rey_Ganador][CORONA_B[Peon]]-1)
         return 0;
	  else if (Distancia[Rey_Perdedor][CORONA_B[Peon]]<= 2 &&
		  FILA[Rey_Perdedor] > 6)return 0;
	  else score = ( VAL_P+ (20*FILA[Peon]))+
		          (5*Distancia[Rey_Perdedor][CORONA_B[Peon]])-
				  (5*Distancia[Rey_Ganador][CORONA_B[Peon]]);

		if (turno == BLANCAS) return score;
				  else return -score;
	  }//Ganador-Blancas

	else if (ganador == NEGRAS){
     if (turno == NEGRAS &&
		  Distancia[Rey_Perdedor][CORONA_N[Peon]]< 
		  Distancia[Rey_Ganador][CORONA_N[Peon]])
         return 0;
	  else if (turno == NEGRAS &&
		  Distancia[Rey_Perdedor][CORONA_N[Peon]]< 
		  Distancia[Rey_Ganador][CORONA_N[Peon]]-1)
         return 0;
	  else if (Distancia[Rey_Perdedor][CORONA_N[Peon]]<= 2 &&
		  FILA[Rey_Perdedor] < 3)return 0;
	  else score = ( VAL_P+ (20*(9-FILA[Peon])))+
		          (5*Distancia[Rey_Perdedor][CORONA_N[Peon]])-
				  (5*Distancia[Rey_Ganador][CORONA_N[Peon]]);
				  if (turno == NEGRAS) return score;
				  else return -score;
	}// Ganador-Negras
  }//Peon en columna de Torre
        
  else { //No esta en colomna de torre

      if (ganador == BLANCAS){

		  //Rey 2 fila delante de la fila del peon
         if (FILA[Rey_Ganador] == FILA[Peon] + 2)
            return (ganador == turno ? score : -score);

          //Rey 1 fila delante de la fila del peon
         if (FILA[Rey_Ganador] == FILA[Peon] + 1){
			 //Rey en fila 6
			if (FILA[Rey_Ganador] == 6)
               return (ganador == turno ? score : -score);
			 //El Rey contrario tiene la oposicion
            if (Rey_Ganador < A6) {
				if (Rey_Ganador +20 == Rey_Perdedor && ganador == turno)
				return (0);
	        else //no tiene la oposicion
                return (ganador == turno ? score : -score); }
         }// 1 fila delante

			 // El Rey esta en la misma fila que el peon
         if (FILA[Rey_Ganador] == FILA[Peon]){
            if ((FILA[Rey_Perdedor] - FILA[Peon] < 2 || 
				FILA[Rey_Perdedor] - FILA[Peon] > 4) &&
		        ganador == turno)
	        return (score);
            if ((FILA[Rey_Perdedor] - FILA[Peon] < 1 || 
				FILA[Rey_Perdedor] - FILA[Peon] > 5) &&
		        perdedor == turno)
            return (-score);
	     if (FILA[Peon] == 6 && Rey_Ganador +20 != Rey_Perdedor)
            return (ganador == turno ? score : 0);
		 }// Misma fila que el peon

		 // Peon en fila 7 y Rey en fila 6
		 if (FILA[Peon] == 7 && FILA[Rey_Ganador] == 6){
			 if (Rey_Perdedor != Peon+10)
		   return (ganador == turno ? score : 0);
		    if (Rey_Perdedor == Peon+8 && Rey_Perdedor == Rey_Ganador+20)
               return (ganador == turno ? score : 0);
		 } //Peon en 7
      } 

	  else { // ganador = NEGRAS

         if (FILA[Rey_Ganador] == FILA[Peon] - 2)
            return (ganador == turno ? score : -score);

         if (FILA[Rey_Ganador] == FILA[Peon] - 1){
			if (FILA[Rey_Ganador] == 3)
               return (ganador == turno ? score : -score);
	    if (Rey_Ganador > H3){
	       if (Rey_Ganador-20 == Rey_Perdedor && ganador == turno)
	          return (0);
	       else
              return (ganador == turno ? score : -score);
	    }	
	 }
         if (FILA[Rey_Ganador] == FILA[Peon]){
            if ((FILA[Peon] - FILA[Rey_Perdedor] < 2 || 
				 FILA[Peon] - FILA[Rey_Perdedor] > 4) &&
				 ganador == turno)
			return (score);
            if ((FILA[Peon] - FILA[Rey_Perdedor] < 1 || 
				 FILA[Peon] - FILA[Rey_Perdedor] > 5) &&
				 perdedor == turno)
	       return (-score);
	    if (FILA[Peon] == 3 && Rey_Ganador-20 != Rey_Perdedor)
           return (ganador == turno ? score : 0);
	 }
	 if (FILA[Peon] == 2 && FILA[Rey_Ganador] == 3){
	    if (Rey_Perdedor != Peon-10)
               return (ganador == turno ? score : 0);
	    if (Rey_Perdedor == Peon-10 && Rey_Perdedor == Rey_Ganador-20)
               return (ganador == turno ? score : 0);
	 }
      } 
   }  

   return (0);
}

//* Si un bando no tiene material y el otro
//* tiene material suficiente para dar mate
int ReySolitario ()
{
  register int ganador, perdedor;
  int score = 0;

if (MaterialBB > MaterialNN){
	ganador      = BLANCAS;
	perdedor     = NEGRAS;
	}

  else {
	ganador      = NEGRAS;
	perdedor     = BLANCAS;
	}

    if(ganador == BLANCAS){
      score = VAL_WIN 
		    - 12 * Distancia[Pos_RB][Pos_RN]
			- TabMateRey[Pos_RN]; 
	}
    else{
      score = VAL_WIN 
		    - 12 * Distancia[Pos_RB][Pos_RN]
			- TabMateRey[Pos_RB];
	}
  
//printf(" Estoy en Rey Solitario \n");
if((ganador == BLANCAS && Color == BLANCAS) ||
   (ganador == NEGRAS  && Color == NEGRAS)){
		store_eval(score, Color);
		return score;
}
else { 
	store_eval(-score, Color);
	return -score;
}
}




