
// SEE, Evaluador estatico de intercambio de fichas.
// Para la codificacion de este algoritmo, me ha sido de gran ayuda, la
// informacion encontrada en Chess Programing Wiki, asi como el codigo
// fuente de los programas KRAFTY, PAWNY, Y SJENG.
// De momento, solo lo utilizo, para podar en Qsearch(), tambien lo he
// probado en ordenar los movimientos, pero el resultado no es satisfactorio.
// Supongo que se podra utilizar para saber si el avance de un peon pasado
// es seguro, o si al mover cualquier ficha, perdemos material, (todo esto
// estaticamente, sin ver que pasara mas adelante).

int see(int ca_or, int ca_dest) {	

typedef struct
{
  int deslizante;
  int direccion;
  int casilla;
} tipo_atacante;

	int i;
	int val;
	int destino;		
	int objetivo;	
	int valor[32];	
	int valor_count;	
	int bando;	
	int num_ataques[2];
	int elmenor;	
	int index_delmenor;	
	int ca_delmenor;	
	int ficha_original;
	int ca;
	//int pasadab = 0, pasadan = 0;
	tipo_atacante atacantes[2][16];

	//inicializamos las variables	
	destino = ca_dest;
    for(i = 0; i < 16; i++){
		atacantes[0][i].casilla =    atacantes[1][i].casilla = 0;
		atacantes[0][i].deslizante = atacantes[1][i].deslizante = 0;
		atacantes[0][i].direccion =  atacantes[1][i].direccion = 0;		
	}
	for(i = 0; i < 32; i++) valor[i] = 0;
	num_ataques[B] = num_ataques[N] = 0;
	valor_count = 0;

	// A quien le toca mover
	if(Color == BLANCAS) bando = 0;
	else bando = 1;

	// Retiramos la primera ficha que se mueve, para que no 
	// enrorpezca la busqueda, tendremos que colocarla en
	// su sitio al final.
	ficha_original = contenido[ca_or];
	contenido[ca_or] = VACIO;

	//peones blancos
	if(contenido[destino-9]== P_B ){
		atacantes[B][num_ataques[B]].casilla = (destino-9);
		num_ataques[B]++;
	}
	if(contenido[destino-11]== P_B ){
		atacantes[B][num_ataques[B]].casilla = (destino-11);
		num_ataques[B]++;
	}
		   
	//peones negros
	if(contenido[destino+9]== P_N ){
		atacantes[N][num_ataques[N]].casilla = (destino+9);
		num_ataques[N]++;
	}
	if(contenido[destino+11]== P_N ){
		atacantes[N][num_ataques[N]].casilla = (destino+11);
		num_ataques[N]++;
	}

	// Caballos
	for (i = 0; i < 8; i++){ 
		if (contenido[destino + Inc_Ca[i]] == C_B){ 
		atacantes[B][num_ataques[B]].casilla = (destino + Inc_Ca[i]);
		num_ataques[B]++;
		}
		else if (contenido[destino + Inc_Ca[i]] == C_N){ 
		atacantes[N][num_ataques[N]].casilla = (destino + Inc_Ca[i]);
		num_ataques[N]++;
		}
	}
	

	// Alfil y Dama 
	for (i = 0; i < 4; i++) { 
          ca = destino + Inc_Al[i];
		  while (contenido[ ca ] == VACIO ) ca += Inc_Al[i];
		    if ( contenido[ ca ] == A_B || contenido[ ca ] == D_B){ 
			atacantes[B][num_ataques[B]].casilla = ca;
			atacantes[B][num_ataques[B]].deslizante = 1;
			atacantes[B][num_ataques[B]].direccion = Inc_Al[i];
			num_ataques[B]++;
			}
			else if ( contenido[ ca ] == A_N || contenido[ ca ] == D_N){ 
			atacantes[N][num_ataques[N]].casilla = ca;
			atacantes[N][num_ataques[N]].deslizante = 1;
			atacantes[N][num_ataques[N]].direccion = Inc_Al[i];
			num_ataques[N]++;
			}

	}//for


	// Torre y Dama 
	for (i = 0; i < 4; i++) { 
          ca = destino + Inc_To[i];
		  while (contenido[ ca ] == VACIO ) ca += Inc_To[i];
		    if ( contenido[ ca ] == T_B || contenido[ ca ] == D_B){ 
			atacantes[B][num_ataques[B]].casilla = ca;
			atacantes[B][num_ataques[B]].deslizante = 2;
			atacantes[B][num_ataques[B]].direccion = Inc_To[i];
			num_ataques[B]++;
			}
			else if ( contenido[ ca ] == T_N || contenido[ ca ] == D_N){ 
			atacantes[N][num_ataques[N]].casilla = ca;
			atacantes[N][num_ataques[N]].deslizante = 1;
			atacantes[N][num_ataques[N]].direccion = Inc_To[i];
			num_ataques[N]++;
			}
	}//for



// Rey blanco
	for (i = 0; i < 8; i++){ 
		if (contenido[destino + Inc_Da[i]] == R_B){ 
		atacantes[B][num_ataques[B]].casilla = (destino + Inc_Da[i]);
		num_ataques[B]++;
		}
        else if (contenido[destino + Inc_Da[i]] == R_N){ 
		atacantes[N][num_ataques[N]].casilla = (destino + Inc_Da[i]);
		num_ataques[N]++;
		}
	}

	//captura limpia, el contrario no ataca la casilla destino
	if(num_ataques[!bando]== 0){
        contenido[ca_or] = ficha_original;
		return ValFicha2[abs(contenido[ca_dest])];
	}

	//Hacemos la captura inicial
	valor[0] = ValFicha2[abs(contenido[ca_dest])];
	valor_count++;
	objetivo =   ValFicha2[abs(ficha_original)];
	bando ^= 1;
	
	//Hacemos el resto de capturas, intercambiando el color
	while(num_ataques[bando])
	{	
		elmenor = VAL_R + 1;
		index_delmenor = 0;
		ca_delmenor = 0;
		//Buscamos el atacante de menor valor
		for(i = 0; i < num_ataques[bando]; i++)
		{	val = ValFicha2[abs(contenido[atacantes[bando][i].casilla])];
			if(val < elmenor)
			{	elmenor = val;
				index_delmenor = i;
			}
		}
		// Miramos si acabamos de utilizar una deslizante, Dama, Alfil o Torre,
		// si es asi, miramos en la misma direccion en la que se encontro esta
		// ficha, para ver si detras habia otra deslizante del mismo color, en
		// el caso de la Torre, volvemos a poner el indicador de deslizante 2,
		// y la direccion, porque pueden ser 3 las fichas dobladas.

		if(atacantes[bando][index_delmenor].deslizante == 1){
			int incremento = atacantes[bando][index_delmenor].direccion;
			int principio =  atacantes[bando][index_delmenor].casilla;
			if(bando == B){
				ca = principio + incremento;
				while (contenido[ ca ] == VACIO ) ca += incremento;
					if ( contenido[ ca ] == A_B || contenido[ ca ] == D_B){ 
					atacantes[B][num_ataques[B]].casilla = ca;
					atacantes[B][num_ataques[B]].deslizante = 0;
					atacantes[B][num_ataques[B]].direccion = 0;
					num_ataques[B]++;
					}
			}
			else {
				ca = principio + incremento;
				while (contenido[ ca ] == VACIO ) ca += incremento;
					if ( contenido[ ca ] == A_N || contenido[ ca ] == D_N){ 
					atacantes[N][num_ataques[N]].casilla = ca;
					atacantes[N][num_ataques[N]].deslizante = 0;
					atacantes[N][num_ataques[N]].direccion = 0;
					num_ataques[N]++;
					}
			}
		}//deslizante == 1

		else if(atacantes[bando][index_delmenor].deslizante == 2){
			int incremento = atacantes[bando][index_delmenor].direccion;
			int principio =  atacantes[bando][index_delmenor].casilla;
			if(bando == B){
				ca = principio + incremento;
				while (contenido[ ca ] == VACIO ) ca += incremento;
					if ( contenido[ ca ] == T_B || contenido[ ca ] == D_B){ 
					atacantes[B][num_ataques[B]].casilla = ca;
					atacantes[B][num_ataques[B]].deslizante = 2;
					atacantes[B][num_ataques[B]].direccion = incremento;
					num_ataques[B]++;
					}
			}
			else {
				ca = principio + incremento;
				while (contenido[ ca ] == VACIO ) ca += incremento;
					if ( contenido[ ca ] == T_N || contenido[ ca ] == D_N){ 
					atacantes[N][num_ataques[N]].casilla = ca;
					atacantes[N][num_ataques[N]].deslizante = 2;
					atacantes[N][num_ataques[N]].direccion = incremento;
					num_ataques[N]++;
					}
			}
		}//deslizante == 2

		//Intercambiamos la posicion de la ficha que hemos utilizado, con la
		//que hemos comparado, para no volver a utilizarla
		ca_delmenor = atacantes[bando][index_delmenor].casilla;
		atacantes[bando][index_delmenor] = atacantes[bando][--num_ataques[bando]];
		atacantes[bando][num_ataques[bando]].casilla = ca_delmenor;
			
		valor[valor_count] = -valor[valor_count-1] + objetivo;
		valor_count ++;
		objetivo = elmenor;
		bando ^= 1;
	}

	while(--valor_count)
	 valor[valor_count - 1] = min(-valor[valor_count], valor[valor_count-1]);
	 contenido[ca_or] = ficha_original;
	return (valor[0]);

}

// Cuando una ficha mayor captura otra menor, si ademas
// la menor se encuentra defendida por un peon, vamos a
// considerarlas una mala captura para ordenarla.
// Para usar antes de hacer el movimiento.
__forceinline bool peon_defiende(int origen,int destino){

// La ficha que captura es blanca
if(contenido[origen] > 1){
	if(contenido[destino +9]  == P_N ||
       contenido[destino +11] == P_N)
	   return true;
}
if(contenido[origen] < 1){
    if(contenido[destino -9] ==  P_B ||
       contenido[destino -11] == P_B)
	   return true;
}
 return false;
}


__forceinline  bool Mala_captura(int origen, int destino) {

	int ca;

	if (abs(contenido[origen]) == R_B || abs(contenido[destino]) == R_B) return false;


	// La ficha que mueve es blanca
	if (contenido[origen] > P_B) {

		//si defiende un peon contrario
		if (contenido[destino + 9] == P_N || contenido[destino + 11] == P_N)
			return true;

		// La ficha que se ha movido es una torre
		if (contenido[origen] == T_B && contenido[destino] == P_N) {

			//si un Caballo contrario controla
			if (contenido[destino + 8] == C_N) return true;
			if (contenido[destino - 8] == C_N) return true;
			if (contenido[destino + 12] == C_N) return true;
			if (contenido[destino - 12] == C_N) return true;
			if (contenido[destino + 19] == C_N) return true;
			if (contenido[destino - 19] == C_N) return true;
			if (contenido[destino + 21] == C_N) return true;
			if (contenido[destino - 21] == C_N) return true;

			//si un Alfil contrario controla
			ca = destino + 9;
			while (contenido[ca] == VACIO)ca += 9;
			if (contenido[ca] == A_N) return true;

			ca = destino - 9;
			while (contenido[ca] == VACIO)ca -= 9;
			if (contenido[ca] == A_N) return true;

			ca = destino + 11;
			while (contenido[ca] == VACIO)ca += 11;
			if (contenido[ca] == A_N) return true;

			ca = destino - 11;
			while (contenido[ca] == VACIO)ca -= 11;
			if (contenido[ca] == A_N) return true;
		}

		// La ficha que se ha movido es una Dama
		if (contenido[origen] == D_B && contenido[destino] >= T_N) { // T,A,C,P
			//si un Caballo contrario controla
			if (contenido[destino + 8] == C_N) return true;
			if (contenido[destino - 8] == C_N) return true;
			if (contenido[destino + 12] == C_N) return true;
			if (contenido[destino - 12] == C_N) return true;
			if (contenido[destino + 19] == C_N) return true;
			if (contenido[destino - 19] == C_N) return true;
			if (contenido[destino + 21] == C_N) return true;
			if (contenido[destino - 21] == C_N) return true;

			//si un Alfil contrario controla
			ca = destino + 9;
			while (contenido[ca] == VACIO)ca += 9;
			if (contenido[ca] == A_N) return true;

			ca = destino - 9;
			while (contenido[ca] == VACIO)ca -= 9;
			if (contenido[ca] == A_N) return true;

			ca = destino + 11;
			while (contenido[ca] == VACIO)ca += 11;
			if (contenido[ca] == A_N) return true;

			ca = destino - 11;
			while (contenido[ca] == VACIO)ca -= 11;
			if (contenido[ca] == A_N) return true;
		}

		if (contenido[origen] == D_B && contenido[destino] >= A_N) { // A,C,P
			  //si un Alfil contrario controla
			ca = destino + 1;
			while (contenido[ca] == VACIO)ca += 1;
			if (contenido[ca] == T_N) return true;

			ca = destino - 1;
			while (contenido[ca] == VACIO)ca -= 1;
			if (contenido[ca] == T_N) return true;

			ca = destino + 10;
			while (contenido[ca] == VACIO)ca += 10;
			if (contenido[ca] == T_N) return true;

			ca = destino - 10;
			while (contenido[ca] == VACIO)ca -= 10;
			if (contenido[ca] == T_N) return true;
		}
		return false;
	}// Blancas


	// La ficha que captura es negra
	else if (contenido[origen] < P_N) {

		if (contenido[destino - 9] == P_B || contenido[destino - 11] == P_B)
			return true;

		if (contenido[origen] == T_N && contenido[destino] == P_B) {

			//si esta defendido por caballo
			if (contenido[destino + 8] == C_B) return true;
			if (contenido[destino - 8] == C_B) return true;
			if (contenido[destino + 12] == C_B) return true;
			if (contenido[destino - 12] == C_B) return true;
			if (contenido[destino + 19] == C_B) return true;
			if (contenido[destino - 19] == C_B) return true;
			if (contenido[destino + 21] == C_B) return true;
			if (contenido[destino - 21] == C_B) return true;

			// O si esta defendido por un alfil
			ca = destino + 9;
			while (contenido[ca] == VACIO)ca += 9;
			if (contenido[ca] == A_B) return true;

			ca = destino - 9;
			while (contenido[ca] == VACIO)ca -= 9;
			if (contenido[ca] == A_B) return true;

			ca = destino + 11;
			while (contenido[ca] == VACIO)ca += 11;
			if (contenido[ca] == A_B) return true;

			ca = destino - 11;
			while (contenido[ca] == VACIO)ca -= 11;
			if (contenido[ca] == A_B) return true;
		} // T x P

		if (contenido[origen] == D_N && contenido[destino] <= T_B) {
			//si esta defendido por caballo
			if (contenido[destino + 8] == C_B) return true;
			if (contenido[destino - 8] == C_B) return true;
			if (contenido[destino + 12] == C_B) return true;
			if (contenido[destino - 12] == C_B) return true;
			if (contenido[destino + 19] == C_B) return true;
			if (contenido[destino - 19] == C_B) return true;
			if (contenido[destino + 21] == C_B) return true;
			if (contenido[destino - 21] == C_B) return true;

			// O si esta defendido por un alfil
			ca = destino + 9;
			while (contenido[ca] == VACIO)ca += 9;
			if (contenido[ca] == A_B) return true;

			ca = destino - 9;
			while (contenido[ca] == VACIO)ca -= 9;
			if (contenido[ca] == A_B) return true;

			ca = destino + 11;
			while (contenido[ca] == VACIO)ca += 11;
			if (contenido[ca] == A_B) return true;

			ca = destino - 11;
			while (contenido[ca] == VACIO)ca -= 11;
			if (contenido[ca] == A_B) return true;
		} // D x T,A,C,P

		if (contenido[origen] == D_N && contenido[destino] <= A_B) {
			ca = destino + 1;
			while (contenido[ca] == VACIO)ca += 1;
			if (contenido[ca] == T_B) return true;

			ca = destino - 1;
			while (contenido[ca] == VACIO)ca -= 1;
			if (contenido[ca] == T_B) return true;

			ca = destino + 10;
			while (contenido[ca] == VACIO)ca += 10;
			if (contenido[ca] == T_B) return true;

			ca = destino - 10;
			while (contenido[ca] == VACIO)ca -= 10;
			if (contenido[ca] == T_B) return true;
		} //D X A, C, P

		return false;
	}// Negras
	return false;
}// mala captura


/*
__forceinline  bool Mala_captura(int origen,int destino){

int ca;
if(abs(contenido[origen]) == R_B) return false;
if(abs(contenido[destino])== R_B) return true;

// La ficha que mueve es blanca
if(contenido[origen] > P_B){
	//si defiende un peon contrario
	if(contenido[destino +9]  == P_N || contenido[destino +11] == P_N)
	   return true;

	// La ficha que se ha movido es una torre o una Dama
	if((contenido[origen] == T_B || contenido[origen] == D_B) && 
		contenido[destino] == P_N){ 
	
        //si un Caballo contrario controla
        if(contenido[destino +8]== C_N) return true;
		if(contenido[destino -8]== C_N) return true;
		if(contenido[destino+12]== C_N) return true;
		if(contenido[destino-12]== C_N) return true;
		if(contenido[destino+19]== C_N) return true;
		if(contenido[destino-19]== C_N) return true;
		if(contenido[destino+21]== C_N) return true;
		if(contenido[destino-21]== C_N) return true;

         //si un Alfil contrario controla
		ca = destino+9;
		while (contenido[ca] == VACIO)ca += 9;
		if(contenido[ca]== A_N) return true;

   		ca = destino-9;
		while (contenido[ca] == VACIO)ca -= 9;
		if(contenido[ca]== A_N) return true;

		ca = destino+11;
		while (contenido[ca] == VACIO)ca += 11;
		if(contenido[ca]== A_N) return true;

		ca = destino-11;
		while (contenido[ca] == VACIO)ca -= 11;
		if(contenido[ca]== A_N) return true;
		}
	

return false;
}// Blancas


// La ficha que captura es negra
if(contenido[origen] < P_N){

    if(contenido[destino -9] ==  P_B || contenido[destino -11] == P_B)
	   return true;

		if((contenido[origen] == T_N || contenido[origen] == D_N) && 
			contenido[destino] == P_B){
		   
        //si esta defendido por caballo
        if(contenido[destino +8]== C_B) return true;
		if(contenido[destino -8]== C_B) return true;
		if(contenido[destino+12]== C_B) return true;
		if(contenido[destino-12]== C_B) return true;
		if(contenido[destino+19]== C_B) return true;
		if(contenido[destino-19]== C_B) return true;
		if(contenido[destino+21]== C_B) return true;
		if(contenido[destino-21]== C_B) return true;

        // O si esta defendido por un alfil
		ca = destino+9;
		while (contenido[ca] == VACIO)ca += 9;
		if(contenido[ca]== A_B) return true;

   		ca =destino-9;
		while (contenido[ca] == VACIO)ca -= 9;
		if(contenido[ca]== A_B) return true;

		ca = destino+11;
		while (contenido[ca] == VACIO)ca += 11;
		if(contenido[ca]== A_B) return true;

		ca = destino-11;
		while (contenido[ca] == VACIO)ca -= 11;
		if(contenido[ca]== A_B) return true;
		}
		
	
return false;
}// Negras
 return false;
}// mala captura

*/

